var Config;

if (typeof(Config) == 'undefined') {
    alert('The functions.js file must be loaded before index.js');
}

/**
 * Make the extension persistent to prevent extension from unloading.
 */
Persistent(true);

/**
 * The main process.
 */
$(function() {

    try {

        // Set extensionID in global scope of Host.

        csInterface.evalScript('$.global.extensionID = "' + csInterface.getExtensionID() + '";', function(result) {
            console.log('$.global.extensionID : ' + result);
        });

        // Initialize the flyout menu.

        initFlyoutMenu();

        // Load external depencies.
        // TODO: This is only needed for dev. All dependencies are being compiled to a single source in the production code.
        // loadDependencies();

        // Create the Host object and initialize the UI.

        csInterface.evalScript( 'createHostInstance()', function(result) {

            console.log('createHostInstance : index.js ' + result);

            if ( ! isTrue(result) ) {
                alert('The Host instance could not be created');
                return;
            }

            var $button     = $("#remove-bg-btn"),
                $account    = $("#my-account-btn"),
                $credits    = $("#buy-credits-btn"),
                $imgSize    = $(".image-size"),
                $image      = $(".current-image"),
                $body       = $('body'),
                $links      = $(".link"),
                $refresh    = $("#refresh-btn"),
                $top        = $("#top-section"),
                $progress   = $("#progress"),
                $indicator  = $('#indicator');

            // $indicator.css({
            //     width: (($progress.data('value') / $progress.data('max')) * 100) + "%"
            // });

            var versionCheck = verifyExtensionVersion();

            if (! hasValidApiKey()) {

                console.log('No API key');

                showConfigureApiKeyMessage();
                showSettingsDialog();
            }
            else {

                if (versionCheck.status != 'ok') {
                    console.log('Version out-of-date');
                    showExtensionVersionMessage(versionCheck);
                }

                Config.USER_AGENT = getUserAgent(
                    csInterface.getExtensionID()
                );

                console.log('USER_AGENT : ' +  Config.USER_AGENT);

                // If we have an API Key, enable the UI

                $body.removeClass('disabled');

                // Grab the account details

                getAccountDetails(true);

                console.log(Config.ACCOUNT);

                // Enable the main button.

                $button.attr("disabled", false);
                $account.attr("disabled", false);
                $credits.attr("disabled", false);

                // Remove Background button (main button)

                $button.on('click', function(e) {

                    try {
                        $button.blur();

                        if (! get(csInterface.getNetworkPreferences(), 'isAppOnline', false)) {

                            var NO_INTERNET_CONNECTION = 'You must be connected to the internet to use Remove BG';
                            csInterface.evalScript('alert("' + NO_INTERNET_CONNECTION + '")', function(result) {
                                setReadyState();
                            });
                            return void(0);
                        }

                        console.log('Setting UI in uploading state');

                        setUploadingState();

                        console.log(_t(
                            'Removing background with max resolution : {s}',
                            {s: Config.ACCOUNT.getMaxSize()}
                        ));

                        removeBackground(Config.ACCOUNT.getMaxSize());
                    }
                    catch(e) {
                        console.log(e);
                    }
                });

                // My Account button

                $account.on('click', function(e) {
                    $account.blur();
                    csInterface.openURLInDefaultBrowser(Config.PROFILE);
                });

                // Buy Credits button

                $credits.on('click', function(e) {
                    $credits.blur();
                    csInterface.openURLInDefaultBrowser(Config.PROFILE_CREDITS);
                });

                // Logo home page link

                $links.on('click', function(e) {
                    var $link = $(this);
                    csInterface.openURLInDefaultBrowser($link.data('url'));
                });

                // Refresh the account details

                $refresh.on('click', function(e) {
                    e.preventDefault();
                    getAccountDetails(true);
                });

                console.log( csInterface.getNetworkPreferences() );
                console.log( csInterface.getHostCapabilities() );
                console.log( csInterface.getHostEnvironment() );

                // The current image

                // TODO: Detect change of activeDocument

                // csInterface.evalScript('host.getActiveDocName()', function(result) {
                //     $image.text(result);
                // });

                // csInterface.evalScript('host.getImageSize()', function(result) {
                //     try {
                //         if (isJSON(result)) {
                //             var dims = JSON.parse(result);
                //             $imgSize.text(
                //                 "{mpix} megapixels".replace('{mpix}', dims.mpix )
                //             );
                //         }
                //         else {
                //             console.log('getImageSize : ' + result);
                //         }
                //     }
                //     catch(e) { console.log(e); }
                // });
            }
        });
    }
    catch(e) {
        console.error(e);
    }
});

function hostTypeOf(theVar) {
    csInterface.evalScript('alert(typeof(' + theVar + '));', function(result) {
        console.log(result);
    })
}

function hostValueOf(theVar) {
    csInterface.evalScript('alert(' + theVar + ');', function(result) {
        console.log(result);
    })
}
