/**
 * SettingsDialogError class.
 * @param message
 * @param stack
 * @constructor
 */
var SettingsDialogError = function(message, stack) {
    this.name    = "SettingsDialogError";
    this.message = message || "Unknown SettingsDialogError";
    this.stack   = stack;
};
SettingsDialogError.prototype = Error.prototype;

/**
 * ImageResolutionError
 * @param message
 * @param stack
 * @constructor
 */
var ImageResolutionError = function(message, stack) {
    this.name    = "ImageResolutionError";
    this.message = message || "The image is too large";
    this.stack   = stack;
};
ImageResolutionError.prototype = Error.prototype;

/**
 * ResizeImageError
 * @param message
 * @param stack
 * @constructor
 */
var ResizeImageError = function(message, stack) {
    this.name    = "ResizeImageError";
    this.message = message || "An unknown error occurred resizing the image";
    this.stack   = stack;
}
ResizeImageError.prototype = Error.prototype;

/**
 * Custom DeleteFileError.
 * @param message
 * @constructor
 */
var DeleteFileError = function(message) {
    this.name    = "DeleteFileError";
    this.message = (message || "The file was not deleted");
    this.code    = "EDELFIL";
}
DeleteFileError.prototype = Error.prototype;

/**
 * Custom ReadFileError.
 * @param message
 * @constructor
 */
var ReadFileError = function(message) {
    this.name    = "ReadFileError";
    this.message = (message || "The file could not be read");
    this.code    = "EREADF";
}
ReadFileError.prototype = Error.prototype;

/**
 * Custom ReadFileError.
 * @param message
 * @constructor
 */
var SaveResultError = function(message) {
    this.name    = "SaveResultError";
    this.message = (message || "The result could not be saved");
    this.code    = "ESAVRE";
}
SaveResultError.prototype = Error.prototype;

/**
 * Custom SaveApiKeyError.
 * @param message
 * @constructor
 */
var SaveApiKeyError = function(message, stack) {
    this.name    = "SaveApiKeyError";
    this.message = (message || "API Key was not saved : " + stack);
    this.stack   = stack;
}
SaveApiKeyError.prototype = Error.prototype;

/**
 * Custom RemoveBackgroundError.
 * @param message
 * @constructor
 */
var RemoveBackgroundError = function(message) {
    this.name    = "RemoveBackgroundError";
    this.message = (message || "The background could not be removed");
    this.code    = "EREMBG";
}
RemoveBackgroundError.prototype = Error.prototype;

/**
 * InstallInfoError
 * @param message
 * @param stack
 * @constructor
 */
var InstallInfoError = function(message, stack){
    this.name    = "InstallInfoError";
    this.message = message || "InstallInfo error";
    this.stack   = stack;
};
InstallInfoError.prototype = Error.prototype;

/**
 * GetExtensionError
 * @param message
 * @param stack
 * @constructor
 */
var GetExtensionError = function(message, stack){
    this.name    = "GetExtensionError";
    this.message = message || "GetExtensionError error";
    this.stack   = stack;
};
GetExtensionError.prototype = Error.prototype;

/**
 *
 * @param message
 * @param stack
 * @constructor
 */
var ApplicationInfoError = function(message, stack) {
    this.name    = 'ApplicationInfoError';
    this.message = message || 'ApplicationInfoError error';
    this.stack   = stack || '';
};
ApplicationInfoError.prototype = Error.prototype;

/**
 *
 * @param message
 * @param stack
 * @constructor
 */
var ExtensionInfoError = function(message, stack) {
    this.name    = 'ExtensionInfoError';
    this.message = message || 'ExtensionInfoError error';
    this.stack   = stack || '';
};
ExtensionInfoError.prototype = Error.prototype;

/**
 *
 * @param message
 * @param stack
 * @constructor
 */
var NoSuchFileError = function(message, stack) {
    this.name    = "NoSuchFileError";
    this.message = message || "The specified file does not exist";
    this.stack   = stack;
}
NoSuchFileError.prototype = Error.prototype;
