
if (typeof(csInterface) == 'undefined' && typeof(CSInterface) != 'undefined') {
    var csInterface = new CSInterface();
}

/**
 * Global counter.
 * @type {number}
 */
var counter = counter || 0;

/**
 * Image resolutions constants.
 * @type {{"4k": number, medium: number, hd: number, regular: number}}
 */
var resolutions = {
    "regular" : 250000,
    "medium"  : 1500000,
    "hd"      : 4000000,
    "4k"      : 10000000,
};

/**
 * Get the USER_DATA folder.
 */
var userDataFolder = (function() {
    var _userDataFolder;
    try {
        _userDataFolder = csInterface.getSystemPath(SystemPath.USER_DATA);
    }
    catch(e) {
        try {
            _userDataFolder = Folder.userData;
        }
        catch(e) {
            alert('logger.info : ' + e);
        }
    }
    return _userDataFolder;
})();

/**
 * Event constants.
 * @type {{KEY_SAVED: string, OPEN_URL: string}}
 */
var Events = {
    KEY_SAVED : 'key_saved',
    OPEN_URL  : 'open_url',
    SLCT      : 'slct'
};

/**
 * Global Config object.
 * @type {{
 *     APP_NAME     : string,
 *     USER_DATA    : *,
 *     LOGFOLDER    : *,
 *     API_KEY      : *,
 *     API_ENDPIONT : *
 * }}
 */
var EXTENSION_ID = 'bg.remove.panel';
Config = {
    EXTENSION_ID     : EXTENSION_ID,
    APP_NAME         : EXTENSION_ID,
    USER_DATA        : userDataFolder +  '/' + EXTENSION_ID,
    LOG_FOLDER       : userDataFolder  + '/' + EXTENSION_ID + '/logs',
    SETTINGS_FILE    : userDataFolder  + '/' + EXTENSION_ID + '/removebg-settings.json',
    API_KEY          : '',
    API_REMOVE_BG    : 'https://api.remove.bg/v1.0/removebg',
    API_ACCOUNT      : 'https://api.remove.bg/v1.0/account',
    ACCOUNT          : undefined,
    PROFILE          : 'https://www.remove.bg/profile',
    PROFILE_API_KEY  : 'https://www.remove.bg/profile#api-key',
    PROFILE_CREDITS  : 'https://www.remove.bg/profile#credits',
    USER_AGENT       : 'Photoshop {ps} Plugin {ext}/CEP {cep} {os}',
    DEBUG            : true
};
