if (! String.prototype.trim) {
    String.prototype.trim = function () {
        return this.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g, '');
    };
}

if (! String.prototype.obfuscate) {
    String.prototype.obfuscate = function () {
        return this.replace(/./g, "*");
    };
}

/**
 * Add Array.indexOf support if not supported natively.
 */
if(!Array.prototype.indexOf) {
    /**
     * Gets the index of an element in an array.
     * @param what
     * @param i
     * @returns {*}
     */
    Array.prototype.indexOf = function(what, i) {
        i = i || 0;
        var L = this.length;
        while (i < L) {
            if(this[i] === what) return i;
            ++i;
        }
        return -1;
    };
}

/**
 * Add Array.remove support.
 * @returns {Array}
 */
Array.prototype.remove = function() {
    var what, a = arguments, L = a.length, ax;
    while (L && this.length) {
        what = a[--L];
        while ((ax = this.indexOf(what)) !== -1) {
            this.splice(ax, 1);
        }
    }
    return this;
};

/*-------------------------------------------------------------------------------------------------------------------------*/
/**
 * Adds JSON library support for engines that do not include it natively.
 */
"object"!=typeof JSON&&(JSON={}),function(){"use strict";function f(t){return 10>t?"0"+t:t}function quote(t){
    return escapable.lastIndex=0,escapable.test(t)?'"'+t.replace(escapable,function(t){var e=meta[t];
            return"string"==typeof e?e:"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+t+'"'}
    function str(t,e){var n,r,o,f,u,i=gap,p=e[t];switch(p&&"object"==typeof p&&"function"==typeof p.toJSON&&(p=p.toJSON(t)),
    "function"==typeof rep&&(p=rep.call(e,t,p)),typeof p){case"string":return quote(p);case"number":return isFinite(p)?String(p):"null";
        case"boolean":case"null":return String(p);case"object":if(!p)return"null";if(gap+=indent,u=[],"[object Array]"===Object.prototype.toString.apply(p)){
            for(f=p.length,n=0;f>n;n+=1)u[n]=str(n,p)||"null";return o=0===u.length?"[]":gap?"[\n"+gap+u.join(",\n"+gap)+"\n"+i+"]":"["+u.join(",")+"]",gap=i,o}
            if(rep&&"object"==typeof rep)for(f=rep.length,n=0;f>n;n+=1)"string"==typeof rep[n]&&(r=rep[n],o=str(r,p),o&&u.push(quote(r)+(gap?": ":":")+o));
            else for(r in p)Object.prototype.hasOwnProperty.call(p,r)&&(o=str(r,p),o&&u.push(quote(r)+(gap?": ":":")+o));return o=0===u.length?"{}":gap?"{\n"+gap+
                    u.join(",\n"+gap)+"\n"+i+"}":"{"+u.join(",")+"}",gap=i,o}}"function"!=typeof Date.prototype.toJSON&&(Date.prototype.toJSON=function(){
        return isFinite(this.valueOf())?this.getUTCFullYear()+"-"+f(this.getUTCMonth()+1)+"-"+f(this.getUTCDate())+"T"+f(this.getUTCHours())+":"+
            f(this.getUTCMinutes())+":"+f(this.getUTCSeconds())+"Z":null},String.prototype.toJSON=Number.prototype.toJSON=Boolean.prototype.toJSON=function(){
        return this.valueOf()});var cx,escapable,gap,indent,meta,rep;"function"!=typeof JSON.stringify&&
    (escapable=/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        meta={"\b":"\\b","  ":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},JSON.stringify=function(t,e,n){var r;
        if(gap="",indent="","number"==typeof n)for(r=0;n>r;r+=1)indent+=" ";else"string"==typeof n&&(indent=n);if(rep=e,
            e&&"function"!=typeof e&&("object"!=typeof e||"number"!=typeof e.length))throw new Error("JSON.stringify");return str("",{"":t})}),
    "function"!=typeof JSON.parse&&(cx=/[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        JSON.parse=function(text,reviver){function walk(t,e){var n,r,o=t[e];if(o&&"object"==typeof o)for(n in o)Object.prototype.hasOwnProperty.call(o,n)&&
        (r=walk(o,n),void 0!==r?o[n]=r:delete o[n]);return reviver.call(t,e,o)}var j;if(text=String(text),cx.lastIndex=0,cx.test(text)&&
            (text=text.replace(cx,function(t){return"\\u"+("0000"+t.charCodeAt(0).toString(16)).slice(-4)})),
                /^[\],:{}\s]*$/.test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g,"@")
                    .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g,"]")
                    .replace(/(?:^|:|,)(?:\s*\[)+/g,"")))return j=eval("("+text+")"),"function"==typeof reviver?walk({"":j},""):j;
            throw new SyntaxError("JSON.parse")})}();
/*-------------------------------------------------------------------------------------------------------------------------*/

/**
 * Write a file to disc.
 * @param {string}  path        The file path to write to
 * @param {string}  txt         The text to write to the file
 * @param {bool}    replace     Whether to replace the file if it already exists
 * @returns {void}
 */
JSON.write = function( path, txt, replace ) {

    var OSType = $.os.search(/windows/i) != -1 ? "WINDOWS" : "MAC" ;

    try {
        var file = new File( path );
        if (replace && file.exists) {
            file.remove();
            file = new File( path );
        }
        file.open("e", "TEXT", "????");
        file.seek(0,2);
        file.lineFeed = 'macintosh';
        if (OSType == 'WINDOWS') {
            file.lineFeed = 'windows';
        }
        file.writeln(txt);
        file.close();
    }
    catch(ex) {
        try { file.close(); }
        catch(ex) {/* Exit Gracefully*/}
    }
};

/**
 * Reads the contents of a file.
 * @param   {File} fp     A file object.
 * @returns  {string}
 */
JSON.read = function(fp) {
    var data = '';

    try {
        fp.open('r', undefined, undefined);
        data = fp.read();
        fp.close();
    }
    catch(e) {
        try { fp.close(); }catch(e){}
        /* Exit gracefully for now */
    }
    return data;
};

/**
 * @author Scott Lewis <scott@atomiclotus.net>
 * @copyright 2019 Scott Lewis
 * @version 1.0.0
 * @url http://github.com/iconifyit
 * @url https://atomiclotus.net
 *
 * PERMISSIONS
 *
 *   Permission is hereby granted, free of charge, to any person obtaining a copy
 *   of this software and associated documentation files (the "Software"), to deal
 *   in the Software without restriction, including without limitation the rights
 *   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *   copies of the Software, and to permit persons to whom the Software is
 *   furnished to do so, subject to the following conditions:
 *
 *   The above copyright notice and this permission notice shall be included in
 *   all copies or substantial portions of the Software.
 *
 *   You are free to use, modify, and distribute this script as you see fit.
 *   No credit is required but would be greatly appreciated.
 *
 * NO WARRANTIES:
 *
 *   THIS SCRIPT IS OFFERED AS-IS WITHOUT ANY WARRANTY OR GUARANTEES OF ANY KIND.
 *   YOU USE THIS SCRIPT COMPLETELY AT YOUR OWN RISK AND UNDER NO CIRCUMSTANCES WILL
 *   THE DEVELOPER AND/OR DISTRIBUTOR OF THIS SCRIPT BE HELD LIABLE FOR DAMAGES OF
 *   ANY KIND INCLUDING LOSS OF DATA OR DAMAGE TO HARDWARE OR SOFTWARE. IF YOU DO
 *   NOT AGREE TO THESE TERMS, DO NOT USE THIS SCRIPT.
 */

/**
 * Create a new logger instance.
 * @param name
 * @param folder
 * @constructor
 */
Logger = function(name, folder) {

    /**
     * Enable or disable logging.
     * @type {boolean}
     */
    this.DEBUG = true ;

    /**
     * Default settings for the logger.
     * @type {{folder: string}}
     */
    this.defaults = {
        folder:  "~/Downloads/cep-boilerplate/logs"
    }

    /**
     * The log folder object.
     * @type {Folder}
     */
    this.folder = new Folder(folder || this.defaults.folder);

    /*
     * Create the log folder if it does not exist.
     */
    if (! this.folder.exists) {
        this.folder.create();
    }

    /**
     * The log file.
     * @type {File}
     */
    this.file = new File(
        this.folder.absoluteURI + "/" + name + "-" + this.dateFormat() + ".log"
    );

};

/**
 * Enable/disable logging.
 * @type {boolean}
 */
Logger.prototype.DEBUG = true;

/**
 * Logger prototype.
 * @type {{
 *     types: {
 *         INFO: string,
 *         WARN: string,
 *         ERROR: string
 *     },
 *     info: Logger.info,
 *     warn: Logger.warn,
 *     error: Logger.error,
 *     log: Logger.log,
 *     remove: Logger.remove,
 *     create: Logger.create
 * }}
 */
Logger.prototype = {

    /**
     * Log message types.
     */
    types: {
        INFO    : localize({en_US: "INFO"}),
        WARN    : localize({en_US: "WARN"}),
        ERROR   : localize({en_US: "ERROR"}),
        INSPECT : localize({en_US: "INSPECT"})
    },

    /**
     * Set debug value.
     * @param {boolean} value
     */
    setDebug: function(value) {
        this.DEBUG = value;
    },

    /**
     * Date string to prefix log entries.
     * @param date
     * @returns {string}
     */
    dateFormat: function() {
        var date = new Date().getTime();
        var d = new Date(date),
            month = '' + (d.getMonth() + 1),
            day = '' + d.getDate(),
            year = d.getFullYear();

        if (month.length < 2) month = '0' + month;
        if (day.length < 2) day = '0' + day;

        return [year, month, day].join('-');
    },

    /**
     * Add info message to log.
     * @param {string}  message     The string message
     * @param {object} vars         An optional object of key => value pairs to replace tokens in string
     */
    info : function(message, vars) {
        this.log(message, this.types.INFO, vars);
    },

    /**
     * Add warning message to log.
     * @param {string}  message     The string message
     * @param {object} vars         An optional object of key => value pairs to replace tokens in string
     */
    warn : function(message, vars) {
        this.log(message, this.types.WARN, vars);
    },

    /**
     * Add error message to log.
     * @param {string}  message     The string message
     * @param {object} vars         An optional object of key => value pairs to replace tokens in string
     */
    error : function(message, vars) {
        this.log(message, this.types.ERROR, vars);
    },

    /**
     * Add message to log.
     * @param {string}  message     The string message
     * @param {object} vars         An optional object of key => value pairs to replace tokens in string
     */
    log : function(message, type, vars) {
        if (! this.DEBUG) return;
        if (typeof(vars) == 'object') {
            message = this._t(message, vars);
        }
        this.write(
            this.file.absoluteURI,
            "[" + this.types[type] + "][" + new Date().toUTCString() + "] " + message
        );
    },

    /**
     * Delete log file.
     * @returns {*|Array}
     */
    remove : function() {
        if (this.file.exists) {
            return this.file.remove();
        }
    },

    /**
     * Create the log file.
     * @param message
     */
    create : function() {
        if (! this.file.exists) {
            return this.file.create();
        }
    },

    /**
     * Prints an object to the log.
     * @param obj
     */
    inspect: function(obj) {
        for (key in obj) {
            try {
                this.log(key + ' : ' + obj[key], this.types.INSPECT);
            }
            catch(e) {
                this.log(key + ' : [' + localize({en_US: 'Internal Error'}) + ']', this.types.INSPECT);
            }

        }
    },

    write: function(path, txt, replace, type) {
        if (typeof(type) == "undefined") {
            type = "TEXT";
        }
        try {
            var file = new File(path);
            if (replace && file.exists) {
                file.remove();
                file = new File(path);
            }
            file.open("e", type, "????");
            file.seek(0,2);
            $.os.search(/windows/i)  != -1 ? file.lineFeed = 'windows'  : file.lineFeed = 'macintosh';
            file.writeln(txt);
            file.close();
        }
        catch(ex) {
            try {
                file.close();
            }
            catch(ex) {
                throw ex.message;
            }
        }
        return true;
    },

    /**
     * Replace tokens in a string with key => value paired vars.
     * @param theText
     * @param theVars
     * @returns {*}
     * @private
     */
    _t : function(theText, theVars) {
        for (token in theVars) {
            theText = theText.replace(
                new RegExp("{" + token + "}","g"),
                theVars[token]
            );
        }
        return theText;
    },

    /**
     * Clear the log folder before writing new log files.
     * @param dirPath
     * @param pattern
     * @returns {string}
     */
    clear: function() {
        var count = 0;
        try {
            var files = this.folder.getFiles("*.log");
            files = files.concat(this.folder.getFiles("*.svg"));
            if (files.length) {
                for (var i=0; i<files.length; i++) {
                    (new File(files[i])).remove();
                    count++;
                }
            }
        }
        catch(e) {
            throw "Logger.rmdir() Error : " + e.message;
        }
        return count + " files were removed";
    }
};

/**
 * @author    Scott Lewis <scott@atomiclotus.net>
 * @copyright 2018 Astute Graphics
 * @version   1.0.0
 * @url       https://astutegraphics.com
 * @url       https://atomiclotus.net
 *
 * ABOUT:
 *
 *    Helper functions for general use.
 *
 * CREDITS:
 *
 *   This extension is based on the CEP Boilerplate extension by Scott Lewis
 *   at Atomic Lotus, LLC.
 *
 * NO WARRANTIES:
 *
 *   You are free to use, modify, and distribute this script as you see fit.
 *   No credit is required but would be greatly appreciated.
 *
 *   THIS SCRIPT IS OFFERED AS-IS WITHOUT ANY WARRANTY OR GUARANTEES OF ANY KIND.
 *   YOU USE THIS SCRIPT COMPLETELY AT YOUR OWN RISK AND UNDER NO CIRCUMSTANCES WILL
 *   THE DEVELOPER AND/OR DISTRIBUTOR OF THIS SCRIPT BE HELD LIABLE FOR DAMAGES OF
 *   ANY KIND INCLUDING LOSS OF DATA OR DAMAGE TO HARDWARE OR SOFTWARE. IF YOU DO
 *   NOT AGREE TO THESE TERMS, DO NOT USE THIS SCRIPT.
 */

/**
 * Test if this class supports the Ai Object type. Before you can use
 * this method, define an array in the global scope named `supportedTypes`.
 * The underscore indicates the array is meant to be private.
 * @param   {string}    theType
 * @returns {boolean}
 * @private
 */
function isSupported(theType) {
    if (typeof(supportedTypes) == 'undefined') {
        throw "You must create a global array named `supportedTypes` with the supported type names";
    }
    return supportedTypes.indexOf(theType.toLowerCase()) >= 0;
}

/**
 * Check the type of an object.
 * @param   {*}         theItem
 * @param   {string}    theType
 * @returns {boolean}
 * @private
 */
function isType(theItem, theType) {
    return strcmp(typeof(theItem), theType);
}

/**
 * Check the typename of an AI Object.
 * @param   {*}         theItem
 * @param   {string}    theTypename
 * @returns {boolean}
 * @private
 */
function isTypename(theItem, theTypename) {
    if (strcmp(theItem.typename, 'undefined')) return false;
    return strcmp(theItem.typename, theTypename);
}

/**
 * Get the typename of an object if it is set.
 * @param   {object}    theItem
 * @returns {string|null}
 */
function getTypename(theItem) {
    if (isDefined(theItem.typename)) return theItem.typename;
    return "undefined";
}

/**
 * Is theItem an object?
 * @param   {*} theItem
 * @returns {*}
 * @private
 */
function isObject(theItem) {
    return isType(theItem, 'object');
}

/**
 * Is theItem a function?
 * @param   {*}         theItem
 * @returns {boolean}
 * @private
 */
function isFunction(theItem) {
    return isType(theItem, 'function');
}

/**
 * Is theItem a string?
 * @param   {*}         theItem
 * @returns {boolean}
 */
function isString(theItem) {
    return isType(theItem, 'string');
}

/**
 * Is theItem a number?
 * @param   {*}         theItem
 * @returns {boolean}
 */
function isNumber(theItem) {
    return ! isNaN(theItem);
}

/**
 * Is this a non-empty string?
 * @param   {*} theItem
 * @returns {boolean}
 */
function isNonEmptyString(theItem) {
    return isDefined(theItem) && isString(theItem) && ! isEmpty(theItem);
}

/**
 * Test if two strings are equal.
 * @param   {string}    theItem
 * @param   {string}    matchCase
 * @returns {boolean}
 */
function areEqual(a, b, matchCase) {
    if (! matchCase) {
        a = a.toLowerCase();
        b = b.toLowerCase();
    }
    return a === b;
}

/**
 * Determine if a value is true-ish.
 * USE ONLY with strings, ints, and booleans.
 * @param   {string|boolean|integer} what
 * @returns {boolean}
 */
function isTrue(what) {

    if (what === true) return true;

    if (isString(what)) {
        var variants = [
            'yes', 'oui', 'ja', 'da',
            'si', 'yeah', 'yep', 'yup',
            'you know it', 'of course'
        ];
        what = what.toLowerCase();
        if (what === "true")     return true;
        if (variants.indexOf(what) != -1) return true;
    }

    if (! isNaN(what)) {
        if (parseInt(what) > 0) return true;
    }

    return false;
}

/**
 * Determine if a value is false-ish.
 * USE ONLY with strings, ints, and booleans.
 * @param   {string|boolean|integer} what
 * @returns {boolean}
 */
function isFalse(what) {

    if (what === false) return true;

    if (isString(what)) {
        var variants = [
            'no', 'non', 'nein', 'nyet',
            'nope', 'nah', 'not a chance', 'nay',
            'fuck no', 'false', 'no way', '0'
        ];
        what = what.toLowerCase();
        if (variants.indexOf(what) != -1) return true;
    }

    if (! isNaN(what)) {
        if (parseInt(what) === 0) return true;
    }

    return false;
}

/**
 * Is theString an error (Starts with the word 'Error')?
 * @param   {string}    theString
 * @returns {boolean}
 */
function isErrorString(theString) {
    if ( theString.substr(0, 5).toLowerCase() == 'error' ) {
        return true;
    }
    if ( theString.toLowerCase().indexOf('typeerror') != -1) {
        return true;
    }
    return false;
}

/**
 * Is theItem a GroupItem?
 * @param   {*}         theItem
 * @returns {boolean}
 * @private
 */
function isGroupItem(theItem) {
    return isTypename(theItem, 'GroupItem');
}

/**
 * Is theItem a PathItem?
 * @param   {*}         theItem
 * @returns {boolean}
 * @private
 */
function isPathItem(theItem) {
    return isTypename(theItem, 'PathItem');
}

/**
 * Is theItem a CompoundPathItem?
 * @param   {GroupItem} theItem
 * @returns {boolean}
 * @private
 */
function isCompoundPathItem(theItem) {
    return isTypename(theItem, 'CompoundPathItem');
}

/**
 * Test if a value is defined.
 * @param   {string}    property
 * @returns {boolean}
 * @private
 */
function isDefined(theItem) {
    return typeof(theItem) != 'undefined';
}

/**
 * If theItem is defined, return it, otherwise set it to theDefault value.
 * @param   {*}     theItem
 * @param   {*)     theDefault
 * @returns {boolean|*}
 */
function isDefinedOr(theItem, theDefault) {
    if (typeof(theItem) != 'undefined') {
        return theItem;
    }
    return theDefault;
}

/**
 * If theItem is not empty, return it, otherwise set it to theDefault value.
 * @param   {*}     theItem
 * @param   {*)     theDefault
 * @returns {boolean|*}
 */
function isEmptyOr(theItem, theDefault) {
    if (! isEmpty(theItem)) {
        return theItem;
    }
    return theDefault;
}

/**
 * Determine if a string is valid JSON.
 * @param   {string}    subject
 * @returns {boolean}
 */
function isJSON(subject) {
    try {
        if (typeof(subject) == 'object') return true;
        if (typeof(JSON.parse(subject)) == 'object') return true;
        return false;
    }
    catch(e) {
        return false;
    }
}

/**
 * Convert a JSON-ish source to string.
 * @param   {JSON|object}   source
 * @returns {string}
 */
function stringify(source) {
    var result;
    try {
        if (isJSON(source)) {
            result = JSON.stringify(source);
        }
        else {
            result = source.toSource();
        }
    }
    catch(e) {
        result = e;
    }
    return result;
}

/**
 * Get the current timestamp.
 * @returns {number}
 * @private
 */
function now() {
    return (new Date()).getTime();
}

/**
 * Ensures a Path ends with a trailing slash.
 * @param   {string}    path
 * @returns {string}
 */
function slash(path) {
    if (path.charAt(path.length-1) != '/') {
        path += '/';
    }
    return path;
};

/**
 * Appends a string to a base string using a divider.
 * @param   {string} base
 * @param   {string} add
 * @param   {string} divider
 * @returns {string}
 * @deprecated
 */
function pack(base, add, divider) {
    divider = typeof(divider) == 'undefined' ? '/' : divider;
    if (base.charAt(base.length-1) != divider) {
        base += divider;
    }
    return base + add;
}

/**
 * Appends a string to a base string using a divider.
 * @param   {string} path
 * @param   {string} subpath
 * @param   {string} separator
 * @returns {string}
 */
function path(path, subpath, separator) {
    separator = typeof(separator) == 'undefined' ? '/' : separator;
    if (path.charAt(path.length-1) != separator) {
        path += separator;
    }
    return path + subpath;
}

/**
 * Trap function execution in a try/catch block.
 * @param   {function}    func
 * @returns {*}
 */
function trap(func, customError) {
    try {
        return func();
    }
    catch(e) {
        return customError || e.message ;
    }
}

/**
 * Format date into a filename-friendly format.
 * @param   {string}  date
 * @returns {string} "YYYY-MM-DD"
 */
function dateFormat(date, separator) {
    if (! isDefined(separator)) {
        separator = "-";
    }
    var d = new Date(date),
        month = '' + (d.getMonth() + 1),
        day   = '' + d.getDate(),
        year  = d.getFullYear();

    if (month.length < 2) month = '0' + month;
    if (day.length < 2) day = '0' + day;

    return [year, month, day].join(separator);
}

/**
 * Test of a variable is completely empty.
 * @param   {*}         data
 * @returns {boolean}
 */
function isEmpty(data) {
    if (typeof(data) == 'number' || typeof(data) == 'boolean') {
        return false;
    }
    if (typeof(data) == 'undefined' || data === null) {
        return true;
    }
    if (typeof(data) == 'string') {
        if (data.trim() == '') {
            return true;
        }
    }
    if (typeof(data.length) != 'undefined') {
        return data.length === 0;
    }
    var count = 0;
    for (var i in data) {
        if (data.hasOwnProperty(i)) count ++;
    }
    return count == 0;
}

/**
 * Convert XML document to string.
 * @param   {XmlDocument} xmlData
 * @returns {string}
 */
function xmlToString(xmlData) {
    //IE
    if (window.ActiveXObject){
        return xmlData.xml;
    }
    // Everyone else.
    return (new XMLSerializer()).serializeToString(xmlData);
}

/**
 * Trim newline chars from a long string.
 * @param   {string}    theText
 * @returns {string}
 */
function trimNewLines(theText) {
    return theText.replace(/\r?\n/g, "");
}

/**
 * Get a value from an object or array.
 * @param   {object|array}    subject
 * @param   {string}          key
 * @param   {*}               fallback
 * @returns {*}
 */
function get( subject, key, fallback ) {
    try {
        return subject[key];
    }
    catch(e) {
        return fallback;
    }
}

/**
 * Setting the active artboard and getting a reference to it are commonly called
 * together so why not do both in  one step?
 * @param   {integer}   idx
 * @returns {Artboard}
 */
function setActiveArtboard(idx) {
    var doc = app.activeDocument;
    doc.artboards.setActiveArtboardIndex(idx);
    return doc.artboards[doc.artboards.getActiveArtboardIndex()];
}

/**
 * Get a specific artboard by its name.
 * @param theName
 * @returns {*}
 */
function getArtboardIndex(theName) {
    try {
        if (app.documents.length == 0) {
            return -1;
        }

        var doc = app.activeDocument;
        var artboards = doc.artboards;

        for ( i = 0; i < artboards.length; i++ ) {
            Host.logger.info(
                'Artboard {name} has index {idx}', {
                    name : artboards[i].name,
                    idx  : i
                });
            if ( artboards[i].name == theName ) {
                return i;
            }
        }

        return -1;
    }
    catch(e) {
        Host.logger.error('getArtboardIndex Error : {error}', {error : e});
        return -1;
    }
}

/**
 * Copies the current selection to the specified artboard and position.
 * @param artboardIndex
 * @param position
 */
function copySelectionToArtboard(artboardIndex, position) {

    // Copy the current selection.

    app.executeMenuCommand('copy');
    doc.selection = null;

    // Activate the target artboard.

    doc.artboards.setActiveArtboardIndex(artboardIndex);
    doc.artboards[doc.artboards.getActiveArtboardIndex()].rulerOrigin = [0, 0];

    // Paste the copied object.

    app.executeMenuCommand('pasteFront');

    // Set the copied object's position.

    var theCopiedItem = doc.selection[0];

    theCopiedItem.position = position;

    // Return a reference to the new object.

    return theCopiedItem;
}

/**
 * Deselect everything.
 */
function deselectAll() {
    try {
        app.executeMenuCommand("deselect");
    } catch(e) {}
}

/**
 * Decrease a number by a given amount.
 * @param {number} a
 * @param {number} b
 * @returns {number}
 */
function minus(a, b) {
    return a <= 0 ? a + b : a - b ;
}

/**
 * Creates a new RGB Color.
 * @param r
 * @param g
 * @param b
 * @returns {RGBColor}
 * @constructor
 */
var RGB = function(r,g,b){
    var c = new RGBColor();
    c.red   = r;
    c.green = g;
    c.blue  = b;
    return c;
};

/**
 * Create a new CMYK color.
 * @param c
 * @param m
 * @param y
 * @param k
 * @returns {CMYKColor}
 * @constructor
 */
var CMYK = function(c,m,y,k) {
    var ink = new CMYKColor();
    ink.cyan   = c;
    ink.magenta = m;
    ink.yellow  = y;
    ink.black  = k;
    return ink;
};

/**
 * Draws diagonal line from lower left to upper right.
 * @param   {PathItems[]} paths
 * @param   {Number}      left
 * @param   {Number}      right
 * @param   {Number}      top
 * @param   {Number}      bottom
 * @returns {PathItem}
 * @constructor
 */
function Diagonal(paths, options) {

    var properties = {
        start       : [0, 0],
        end         : [100, 100],
        color       : new RGB(128, 128, 128),
        strokeWidth : 1,
        stroked     : true,
        filled      : false
    };

    for (key in options) {
        properties[key] = options[key];
    }

    path = paths.add();
    path.setEntirePath([properties.start, properties.end]);
    path.stroked     = properties.stroked;
    path.strokeColor = properties.color;
    path.strokeWidth = properties.strokeWidth;

    return path;
}

/**
 * Creates a new rectangle
 * @param x
 * @param y
 * @param width
 * @param height
 * @returns {Array}
 * @constructor
 */
var Rectangle = function(x, y, width, height) {
    var l = 0;
    var t = 1;
    var r = 2;
    var b = 3;

    var rect = [];

    rect[l] = x;
    rect[t] = -y;
    rect[r] = width + x;
    rect[b] = -(height - rect[t]);

    return rect;
};

/**
 * Add leading zeroes to an integer.
 * @param   {int} num      The number to which to add leading zeros.
 * @param   {ing} zeros    The length of the resulting string.
 * @returns {str}
 */
function addLeadingZeros(num, width) {
    return String(Math.pow(10, width) + num).slice(-width) ;
}

/**
 * Repeat a string for length.
 * @param str
 * @param len
 * @returns {string}
 */
function repeat(str, len) {
    return (String(Math.pow(10, len)).substring(1,len+1)).replace(/0/g, str);
}

/**
 * Use scaling to account for floating point math issues in JavaScript.
 * @param num
 * @returns {number}
 */
function round(num) {
    return Math.round((num + 0.00001) * 100) / 100 ;
}

/**
 * Represent a number as a fixed decimal float.
 * @param n
 * @param len
 * @returns {string}
 */
function toFixed(n, len) {
    if (String(n).indexOf('.') == -1) {
        return n + '.' + repeat('0', len);
    }
    var str  = String(n);
    var bits = str.split('.');
    var num  = bits.shift();
    var dec  = bits.pop();
        dec  = dec.slice(0, len);

    if (dec.length < len) {
        dec = dec + repeat('0', len - dec.length);
    }
    return String(num + '.' + dec);
}

/**
 * Calculate megapixels from width & height.
 * @param width
 * @param height
 * @returns {number}
 */
function calcMegaPixels(width, height) {
    return toFixed((width * height) / 1000000, 2);
}

/**
 * Case-insensitive string comparison.
 * @param aText
 * @param bText
 * @returns {boolean}
 */
function strcmp(aText, bText) {
    return aText.toLowerCase() == bText.toLowerCase();
}

/**
 * Replace tokens in a string with key => value paired vars.
 * @param theText
 * @param theVars
 * @returns {*}
 * @private
 */
function _t(theText, theVars) {
    for (token in theVars) {
        theText = theText.replace(
            new RegExp("{" + token + "}","g"),
            theVars[token]
        );
    }
    return theText;
}

/**
 * Send error message to all outputs.
 * @param message
 * @param vars
 */
function error(message, vars) {
    message = typeof(vars) != 'undefined' ? _t(message, vars) : message ;
    trap(function() { console.error(message);}, null);
    trap(function() { csInterface.evalScript( 'host.logger.error("' + message + '")' ); }, null);
    trap(function() { host.logger.error(message); }, null);
}

/**
 * Send info message to all outputs.
 * @param message
 * @param vars
 */
function info(message, vars) {
    message = typeof(vars) != 'undefined' ? _t(message, vars) : message ;
    trap(function() { console.log(message);}, null);
    trap(function() { csInterface.evalScript( 'host.logger.info("' + message + '")' ); }, null);
    trap(function() { host.info.error(message); }, null);
}

/**
 * Returns a random integer between min (inclusive) and max (inclusive).
 * The value is no lower than min (or the next integer greater than min
 * if min isn't an integer) and no greater than max (or the next integer
 * lower than max if max isn't an integer).
 * Using Math.round() will give you a non-uniform distribution!
 */
function getRandomInt(min, max, omit) {

    var x, num;

    if (typeof(omit) == 'number')    omit = [omit];
    if (typeof(omit) == 'undefined') omit = [];
    min = Math.ceil(min);
    max = Math.floor(max);
    num = Math.floor(Math.random() * (max - min + 1)) + min;
    x = 0;
    while (omit.indexOf(num) != -1 && x <= 9999) {
        x++;
        num = Math.floor(Math.random() * (max - min + 1)) + min;
    }
    return num;
}

/**
 * Move an object vertically.
 * @param {PageItem | selection}    theItem
 * @param {number}                  amount
 * @returns {*}
 */
function moveVertical(theItem, amount) {
    return move(theItem, 0, amount);
}

/**
 * Move an object horizontally.
 * @param {PageItem | selection}    theItem
 * @param {number}                  amount
 * @returns {*}
 */
function moveHorizontal(theItem, amount) {
    return move(theItem, amount, 0);
}

/**
 * Move an object.
 * @param {PageItem | selection}    theItem
 * @param {number}                  left
 * @param {number}                  top
 * @returns {*}
 */
function move(theItem, left, top) {
    try {
        var xy = theItem.position;

        left = typeof(left) == 'undefined' ? 0 : left;
        top  = typeof(top)  == 'undefined' ? 0 : top;

        theItem.position = new Point(
            xy[0] + left,
            xy[1] + top
        );
    }
    catch(e) {
        throw new Error(e);
    }
}

/**
 * Resize current document (in pixels).
 * @param  {Number}  width
 * @param  {Number}  height
 * @return {Boolean}
 */
function resizeImage(width, height) {
    var startRulerUnits     = app.preferences.rulerUnits,
        startTypeUnits      = app.preferences.typeUnits,
        startDisplayDialogs = app.displayDialogs;

    try {
        app.displayDialogs = DialogModes.NO;
        app.preferences.rulerUnits = Units.PIXELS;
        app.preferences.typeUnits = TypeUnits.PIXELS;

        app.activeDocument.resizeImage(width, height, 72, ResampleMethod.BICUBIC);

        app.displayDialogs = startDisplayDialogs;
        app.preferences.rulerUnits = startRulerUnits;
        app.preferences.typeUnits = startTypeUnits;
    } catch (e) {
        return false;
    }

    // Reset
    if (startDisplayDialogs !== undefined) { app.displayDialogs = startDisplayDialogs; }
    if (startRulerUnits     !== undefined) { app.preferences.rulerUnits = startRulerUnits; }
    if (startTypeUnits      !== undefined) { app.preferences.typeUnits = startTypeUnits; }

    return true;
}


/**
 * Calculate megapixels from width and height of an image.
 * @param   {number}    width
 * @param   {number}    height
 * @returns {number}
 */
function calculateMegaPixels(width, height) {
    var mp = (width * height) / 1000000;
    return Math.round((mp + 0.00001) * 100) / 100 ;
}

/**
 * Scale an image by megapixels.
 * @param   {number}    width   The original width
 * @param   {number}    height  The original height
 * @param   {number}    target  The target size in megapixels.
 * @returns {number[]}
 */
function scaleByMegapixels(width, height, target) {
    var mp    = calculateMegaPixels(width, height);
    var scale = Math.min(mp, target) / Math.max(mp, target);

    return [
        Math.sqrt((width * width) * scale),
        Math.sqrt((height * height) * scale)
    ]
}


/**
 * Wrap the selection bounds in a object usable class.
 * @param selection
 * @returns {{bottom: *, UnitValue, right: *, top: *, left: *, x: *, y1: *, width: *, x1: *, y: *, y2: *, x2: *, height: *}}
 * @constructor
 */
var SelelectionDimensions = function() {

    /**
     * The selection bounds.
     * @private
     */
    var _bounds = activeDocument.selection.bounds;

    /**
     * The UnitValue.type
     * @private
     */
    var _unit   = _bounds[0].type;

    /**
     * The left edge coordinate.
     * @private
     */
    var _left   = _bounds[0].value;

    /**
     * The top edge coordinate.
     * @private
     */
    var _top    = _bounds[1].value;

    /**
     * The right edge coordinate.
     * @private
     */
    var _right  = _bounds[2].value;

    /**
     * The bottom edge coordinate.
     * @private
     */
    var _bottom = _bounds[3].value;

    /**
     * The selection width.
     * @type {number}
     * @private
     */
    var _width  = new Number(_right - _left);

    /**
     * The selection height.
     * @type {number}
     * @private
     */
    var _height = new Number(_bottom - _top);


    /**
     * The public interface for this class.
     */
    return {
        unit      : _unit,
        top       : _top,
        left      : _left,
        right     : _right,
        bottom    : _bottom,
        x         : _left,
        x1        : _left,
        x2        : _right,
        y         : _top,
        y1        : _top,
        y2        : _bottom,
        width     : _width,
        height    : _height
    }
};

/**
 * @author Scott Lewis <scott@vectoricons.net>
 * @license The MIT License (MIT)
 * @copyright 2017 Scott Lewis
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * Lets get started.
 * @type {boolean}
 */
// $.localize = true;

/**
 * Our base object.
 * @type {{}}
 */
Utils = new Object();

/**
 * Turn off displaying alerts.
 */
Utils.displayAlertsOff = function() {
    userInteractionLevel = UserInteractionLevel.DONTDISPLAYALERTS;
};

/**
 * Turn on displaying alerts.
 */
Utils.displayAlertsOn = function() {
    try {
        userInteractionLevel = UserInteractionLevel.DISPLAYALERTS;
    }
    catch(e) {/* Exit Gracefully */}
}

/**
 * Get a value from an object or array.
 * @param   {object|array}    subject
 * @param   {string}          key
 * @param   {*}               dfault
 * @returns {*}
 */
Utils.get = function( subject, key, dfault ) {
    var value = dfault;
    if (subject.hasOwnProperty(key)) {
        value = subject[key];
    }
    return value;
};

/**
 * Extends {Object} target with properties from {Object} source.
 * No new properties are added to the object meaning only properties that
 * exist in both source and target will be updated.
 * @param target
 * @param source
 * @returns {*}
 */
Utils.update = function(target, source) {
  for (key in source) {
      if (target.hasOwnProperty(key)) {
          target[key] = source[key];
      }
  }
  return target;
};

/**
 * Extends {Object} target with properties from {Object} source.
 * Any values that are already set will not be updated. New properities
 * will be added to the object.
 * @param target
 * @param source
 * @returns {*}
 */
Utils.extend = function(target, source) {
    for (key in source) {
        if (target.get(key, false)) {
            continue;
        }
        target[key] = source[key];
    }
    return target;
};

/**
 * Open a file dialog.
 * @param   {File} file           The file object
 * @param   {String} title        The dialog title
 * @param   {String} file_filter  The file filter pattern
 * @returns {*}
 */
Utils.chooseFile = function(oFile, title, file_filter) {
    if (! oFile instanceof File) var oFile = new File();
    if (! title) var title  = LANG.CHOOSE_FILE;
    if (! filter) var filter = "*";
    return oFile.openDlg(
        title,
        file_filter,
        false
    );
};

/**
 * Gets the screen dimensions and bounds.
 * @returns {{left: *, top: *, right: *, bottom: *}}
 */
Utils.getScreenSize = function() {
    var screen;

    for (i=0; i<$.screens.length; i++) {
        if ($.screens[i].primary == true) {
            screen = $.screens[i];
            screen.width = screen.right - screen.left;
            screen.height = screen.bottom - screen.top;
        }
    }
    return screen;
};

/**
 * Create a new dialog, centered on screen.
 * @param type
 * @param width
 * @param height
 * @param title
 * @returns {window}
 */
Utils.window = function(type, title, width, height) {
    var dialog = new Window(
        type, title,
        [0, 0, width, height]
    );
    dialog.center();
    return dialog;
};

/**
 * Saves the file in AI format.
 * @param {document} doc            The document object to save
 * @param {string}   path           The file destination path
 * @param {int}      compatibility  The Adobe Illustrator format (version)
 * @return void
 */
Utils.saveFileAsAi = function( doc, path, compatibility ) {
    if (app.documents.length > 0) {
        var theDoc  = new File(path);
        var options = new IllustratorSaveOptions();
        if (typeof(compatibility) == 'undefined') {
            compatibility = Compatibility.ILLUSTRATOR19;
        }
        options.compatibility = compatibility;
        options.flattenOutput = OutputFlattening.PRESERVEAPPEARANCE;
        options.pdfCompatible = true;
        doc.saveAs(theDoc, options);
    }
};

/**
 *
 * @param {string}  str
 * @returns {XML|string|void}
 */
Utils.trim = function(str) {
    return str.replace(/^\s+|\s+$/g, '');
};

/**
 * Logging for this script.
 * @param {string} message      The logging text
 * @return void
 * @deprecated
 */
Utils.logger = function(message, line, filename) {

    if (! CONFIG) {
        CONFIG = {
            LOG_FOLDER    : "/var/log/",
            LOG_FILE_PATH : "/var/log/extendscript-utils-" + Utils.dateFormat(new Date().getTime()) + ".log"
        }
    }

    message = message + "\n" + $.error + "\n\nSTACK TRACE: \n\n" + $.stack;

    try {
        Utils.folder( CONFIG.LOG_FOLDER );
        Utils.write_file(CONFIG.LOG_FILE_PATH, "[" + new Date().toUTCString() + "] " + message);
    }
    catch(ex) {
        alert([line, filename, message].join(' - '));
    }
};

/**
 * Logging for this script.
 * @param {string}  path        The file path
 * @param {string}  txt         The text to write
 * @param {bool}    replace     Replace the file
 * @return void
 */
Utils.write_file = function( path, txt, replace ) {
    try {
        var file = new File( path );
        if (replace && file.exists) {
            file.remove();
            file = new File( path );
        }
        file.open("e", "TEXT", "????");
        file.seek(0,2);
        $.os.search(/windows/i)  != -1 ? file.lineFeed = 'windows'  : file.lineFeed = 'macintosh';
        file.writeln(txt);
        file.close();
        return true;
    }
    catch(ex) {
        try { file.close(); }
        catch(ex) {/* Exit Gracefully*/}
        return fasle;
    }
};

/**
 * Writes a file and calls a callback.
 * @param   {string}    path        The file path
 * @param   {string}    txt         The text to write
 * @param   {function}  callback    The callback to execute.
 * @returns {*}                     The result of the callback.
 */
Utils.write_and_call = function( path, txt, callback ) {
    try {
        var file = new File( path );
        if (file.exists) {
            file.remove();
            file = new File( path );
        }
        file.open("e", "TEXT", "????");
        file.seek(0,2);
        $.os.search(/windows/i)  != -1 ? file.lineFeed = 'windows'  : file.lineFeed = 'macintosh';
        file.writeln(txt);
        file.close();
        return callback.call(this, file);
    }
    catch(ex) {
        try {
            file.close();
        }
        catch(ex) {/* Exit Gracefully*/}
        throw ex;
    }
};

/**
 *
 * @param {string}  path
 * @param {object}  json
 * @param {bool}    replace
 */
Utils.write_json_file = function( path, json ) {
    try {
        return Utils.write_file(path, JSON.stringify(json), true);
    }
    catch(ex) {
        Utils.logger(ex, $.line, $.fileName);
        return false;
    }
};

/**
 * Write to a file and execute the file (for a web shortcut for instance).
 * @param filePath
 * @param theText
 */
Utils.write_exec = function(filePath, theText) {
    try {
        var _file = new File(filePath);
        _file.open( 'w' );
        _file.write( theText );
        _file.close();
        _file.execute();
    }
    catch(e) {
        try {
            _file.close();
        }
        catch(e) {
            /* This will likely fail but just in case, clean up after ourselves and move on. */
        }
        Utils.dump("[Utils.write_exec()] " + e.message);
        throw new Error(e.message);
    }
    return true;
};

/**
 * Reads the contents of a file.
 * @param   {string}  filepath
 * @returns {string}
 */
Utils.read_file = function( filepath ) {

    var content = "";

    var theFile = new File(filepath);

    if (theFile) {

        try {
            if (theFile.alias) {
                while (theFile.alias) {
                    theFile = theFile.resolve().openDlg(
                        LANG.CHOOSE_FILE,
                        "",
                        false
                    );
                }
            }
        }
        catch(ex) {
            dialog.presetsMsgBox.text = ex.message;
        }

        try {
            theFile.open('r', undefined, undefined);
            if (theFile !== '') {
                content = theFile.read();
                theFile.close();
            }
        }
        catch(ex) {

            try { theFile.close(); }catch(ex){};
            Utils.logger(ex, $.line, $.fileName);
        }
    }
    return content;
};

/**
 *
 * @param {string}  filepath
 * @returns {*}
 */
Utils.read_json_file = function(filepath) {
    var contents, result;
    try {
        if ( contents = Utils.read_file( filepath ) ) {
            result = JSON.parse(contents);
            if ( typeof(result) != 'object') {
                result = null;
            }
        }
    }
    catch(ex) {
        // Utils.logger(ex, $.line, $.fileName);
        logger.error(ex);
    }
    return result;
};

/**
 * Replace Mac's tilde home alias with full path.
 * @param {string}      path    The path to de-mac.
 * @returns {string}
 */
Utils.expand_path = function(path, root_path) {
    return path.replace('~/', root_path);
};

/**
 * Get saved configuration JSON.
 * @param {String}  config_file     Path to the config file.
 * @returns {{}}
 */
Utils.get_config = function(config_file) {
    var configFile = new File(config_file);
    var config = {};
    try {
        if (configFile.exists) {
            config = JSON.parse(Utils.read_file(configFile));
        }
    }
    catch(e) {
        logger.error($.localize(e.message));
    }
    return config;
};

/**
 *
 * @param {string}  filepath
 * @param {bool}    mustconfirm
 */
Utils.deleteFile = function( filepath, mustconfirm ) {
    try {
        if (mustconfirm && ! confirm(LANG.CONFIRM_DELETE_PRESET)) {
            return;
        }
        new File(filepath).remove();
    }
    catch(ex) {
        Utils.logger($.line + ' - ' + $.fileName + ' - ' + $.error);
    }
};

/**
 * Initialize a folder.
 * @param {string}  path
 */
Utils.folder = function( path ) {
    var theFolder = new Folder( path );
    if (! theFolder.exists) {
        theFolder.create();
    }
    return theFolder;
};

/**
 * Get all files in sub-folders.
 * @param   {string}  srcFolder
 * @returns {Array}
 */
Utils.getFilesInSubfolders = function( srcFolder ) {

    var allFiles, theFolders, svgFileList;

    if ( ! srcFolder instanceof Folder) return;

    allFiles    = srcFolder.getFiles();
    theFolders  = [];
    svgFileList = [];

    for (var x=0; x < allFiles.length; x++) {
        if (allFiles[x] instanceof Folder) {
            theFolders.push(allFiles[x]);
        }
    }

    if (theFolders.length == 0) {
        svgFileList = srcFolder.getFiles(/\.svg$/i);
    }
    else {
        for (var x=0; x < theFolders.length; x++) {
            fileList = theFolders[x].getFiles(/\.svg$/i);
            for (var n = 0; n<fileList.length; n++) {
                svgFileList.push(fileList[n]);
            }
        }
    }
    return svgFileList;
};

/**
 * Get the basename of a file path.
 * @param path
 * @returns {*}
 */
Utils.basename = function(path) {
    var basename = null;
    try {
        basename = path.split('/').pop();
    }
    catch(e) {
        Utils.logger($.line + ' - ' + $.fileName + ' - ' + $.error);
    }
    return basename;
};

/**
 * Format the date in YYYY-MM-DD format
 * @param {string}  date  The date in timestring format
 * @return {string} date string in YYYY-MM-DD format (2015-10-06)
 */
Utils.dateFormat = function(date) {
    var d = new Date(date),
        month = '' + (d.getMonth() + 1),
        day = '' + d.getDate(),
        year = d.getFullYear();

    if (month.length < 2) month = '0' + month;
    if (day.length < 2) day = '0' + day;

    return [year, month, day].join('-');
};

/**
 * Stringify an object.
 * @param   {object}  obj
 * @returns {string}
 */
Utils.objectToString = function(obj) {
    var items = [];
    for (key in obj) {
        var value = obj[key];
        if (typeof(value) == "array") {
            for (var i=0; i<value.length; i++) {
                value[i] = '"' + value[i] + '"';
            }
            value = '[' + value.join(',') + ']';
        }
        else if (typeof(value) == 'object') {
            value = objectToString(value);
        }
        items.push('"' + key + '": "' + value + '"');
    }
    return "{" + items.join(',') + "}";
};

/**
 * Align objects to nearest pixel.
 * @param {array}   sel     Selection array
 */
Utils.alignToNearestPixel = function(sel) {

    try {
        if (typeof sel != "object") {
            Utils.logger($.line + ' - ' + $.fileName + ' - ' + LANG.NO_SELECTION);
        }
        else {
            for (i = 0 ; i < sel.length; i++) {
                sel[i].left = Math.round(sel[i].left);
                sel[i].top = Math.round(sel[i].top);
            }
            redraw();
        }
    }
    catch(ex) {
        Utils.logger($.line + ' - ' + $.fileName + ' - ' + $.error);
    }
};

/**
 * Cleans up the filename/artboardname.
 * @param   {String}    name    The name to filter and reformat.
 * @returns  {String}            The cleaned up name.
 */
Utils.filterName = function(name) {
    return decodeURIComponent(name).replace(' ', '-');
}

/**
 * Test if all parents are visible & unlocked.
 * @param {object} item
 * @returns {boolean}
 */
Utils.isVisibleAndUnlocked = function(item) {
    return ! Utils.anyParentLocked(item) && ! Utils.anyParentHidden(item);
};

/**
 * Derived from P. J. Onori's Iconic SVG Exporter.jsx
 * @param {object} item
 * @returns {boolean}
 */
Utils.anyParentLocked = function(item) {
    while ( item.parent ) {
        if ( item.parent.locked ) {
            return true;
        }
        item = item.parent;
    }
    return false;
};

/**
 * Derived from P. J. Onori's Iconic SVG Exporter.jsx
 * @param {object} item
 * @returns {boolean}
 */
Utils.anyParentHidden = function(item) {
    while ( item.parent ) {
        if ( item.parent.hidden ) {
            return true;
        }
        item = item.parent;
    }
    return false;
};

/**
 * Groups selected items.
 * @returns void
 */
Utils.groupSelection = function() {
    try {
        app.executeMenuCommand('group');
    }
    catch(e) {
        alert(localize({en_US: "Items could not be grouped (line: %1, file: %2)"}, $.line, $.fileName));
    }
};

/**
 * Display a new progress bar.
 * @param maxvalue
 * @returns {*}
 */
Utils.showProgressBar = function(maxvalue) {

    var top, right, bottom, left;

    if ( bounds = Utils.getScreenSize() ) {
        left = Math.abs(Math.ceil((bounds.width/2) - (450/2)));
        top = Math.abs(Math.ceil((bounds.height/2) - (100/2)));
    }

    var progress = new Window("palette", 'Progress', [left, top, left + 450, top + 120]);
    progress.pnl = progress.add("panel", [10, 10, 440, 100], 'Progress');
    progress.pnl.progBar = progress.pnl.add("progressbar", [20, 45, 410, 60], 0, maxvalue);
    progress.pnl.progBarLabel = progress.pnl.add("statictext", [20, 20, 320, 35], "0 of " + maxvalue);

    progress.show();

    Utils.progress = progress;
};

/**
 * Hides and destroys the progress bar.
 */
Utils.hideProgressBar = function() {
    Utils.progress.hide();
    Utils.progress = null;
}

/**
 * Updates the progress bar.
 * @param progress
 * @returns {*}
 */
Utils.updateProgress = function(message) {
    Utils.progress.pnl.progBar.value++;
    var val = Utils.progress.pnl.progBar.value;
    var max = Utils.progress.pnl.progBar.maxvalue;
    Utils.progress.pnl.progBarLabel.text = val + ' of ' + max + ' - ' + message;
    $.sleep(10);
    Utils.progress.update();
};

/**
 * Updates the progress bar.
 * @param progress
 * @returns {*}
 */
Utils.updateProgressMessage = function(message) {
    var val = Utils.progress.pnl.progBar.value;
    var max = Utils.progress.pnl.progBar.maxvalue;
    Utils.progress.pnl.progBarLabel.text = val + ' of ' + max + ' - ' + message;
    $.sleep(10);
    Utils.progress.update();
};

/**
 * Alias for localize function.
 * @param str
 * @param vars
 * @returns {*}
 */
Utils.i18n = function(str, vars) {
    return localize({en_US: str}, vars);
};

/**
 * Converts a string, array, or object to dash-separated string.
 * @param   {string|array|object}   subject    A string, array, or object to convert to a slug.
 * @returns {string}                           The cleaned up name.
 */
Utils.slugger = function(subject) {
    if (typeof(subject) == "array") {
        return subject.join('-');
    }
    else if (typeof(subject) == "object") {
        var bits = [];
        for (key in subject) {
            if (typeof(subject[key]) != "string") continue;
            bits.push(subject[key].toLowerCase());
        }
        return bits.join('-');
    }
    else if (typeof(subject) == "string") {
        return decodeURIComponent(subject).replace(' ', '-');
    }
    return subject;
};

/**
 * Gets the artboard index of the current selection. This is a brute-force approach
 * and not the ideal solution but it's the best we can currently do.
 * @author  carlos canto 09/28/2013
 * @see     http://forums.adobe.com/message/5721205?tstart=0#5721205
 * @param   {GroupItem}     The selection for which see want the artboard.
 * @returns {integer}       Returns the index of the artboard.
 */
Utils.getArtboardOfGroupItem = function(groupItem) {

    var index = -1;
    var doc   = app.activeDocument;

    // Loop through each artboard.
    for(i=0; i<doc.artboards.length; i++) {

        // Activate each artboard.
        doc.artboards.setActiveArtboardIndex(i);

        // Select all items on the artboard.
        doc.selectObjectsOnActiveArtboard();

        // Test our original selection to see if it is now selected.
        index = doc.artboards.getActiveArtboardIndex();

        if (groupItem.selected) {
            return doc.artboards.getActiveArtboardIndex();
        }

        // We didn't find our object, keep going.
        doc.selection = null;
    }

    return index;
};

/**
 * Get the index of an artboard by its name.
 * @param {string} name
 * @returns {number}
 */
Utils.getArtboardIndexByName = function(name) {
    var doc = app.activeDocument;
    if (artboard = doc.artboards.getByName(name)) {
        for (i = 0; i < doc.artboards.length; i++) {
            if (doc.artboards[i] == artboard) {
                return i;
            }
        }
    }
    return -1;
};

/**
 * Get the artboard index using the name of the items on the artboard.
 * @param itemName
 * @returns {number}
 */
Utils.getArtboardIndexItemByName = function(itemName) {

    var index = -1;
    var doc   = app.activeDocument;

    // Loop through each artboard.
    for(i = 0; i < doc.artboards.length; i++) {

        // Activate each artboard.
        doc.artboards.setActiveArtboardIndex(i);

        // Select all items on the artboard.
        doc.selectObjectsOnActiveArtboard();

        logger.info("Checking artboard " + i + " for item " + itemName);

        if (doc.selection.length) {
            logger.info("Selected items on artboard " + i);
            if (typeof(doc.selection.name) != "undefined") {
                logger.inf("Found named selection on artboard " + i);
                if (doc.selection.name.toUpperCase() == itemName.toUpperCase()) {
                    logger.info("Found item " + itemName + " on artboard " + i);
                    return doc.artboards.getActiveArtboardIndex();
                }
            }
        }

        // We didn't find our object, keep going.
        doc.selection = null;
    }

    return index;
}

/**
 * Set active artboard by name.
 * @param {string} name
 */
Utils.setActiveArtboardByName = function(name) {
    var doc = app.activeDocument;
    doc.artboards.setActiveArtboardIndex(Utils.getArtboardIndexByName(name));
};

/**
 * Get a unique universal identifier.
 * RFC4122 version 4 compliant.
 * @returns {string}
 */
Utils.generateUUID = function() {
    var d = new Date().getTime();
    if (typeof performance !== 'undefined' && typeof performance.now === 'function'){
        d += performance.now(); //use high-precision timer if available
    }
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c === 'x' ? r : (r & 0x3 | 0x8)).toString(16);
    });
};

/**
 * @experimental
 * Rename artboard groupItems by artboard name
 */
Utils.renameGroupItemsByArtboardNames = function() {
    var doc = app.activeDocument;
    for (i = 0; i < doc.artboards.length; i++) {
        doc.artboards.setActiveArtboardIndex(i);
        var ab = doc.artboards[doc.artboards.getActiveArtboardIndex()];
        doc.selectObjectsOnActiveArtboard();
        app.executeMenuCommand('group');
        selection.name = ab.name.indexOf("Artboard ") != -1 ? "Group " + i : ab.name;
    }
};

/**
 * Opens a folder in the Finder. If `thePath` is not defined,
 * the active document in Illustrator will be used. If no documents
 * are open, it will error out.
 * @param {string} thePath
 */
Utils.showInFinder = function(thePath) {
    if (typeof(thePath) == 'undefined' && app.documents.length > 0) {
        thePath = app.activeDocument.path;
    }
    try {
        new Folder(thePath).execute();
    }
    catch(e) {
        alert(e);
    }
};

/**
 * Settings dialog object.
 * @returns {*}
 * @constructor
 */
SettingsDialog = function(Config) {

    /**
     * Save the API key to the settings file.
     * @param key
     * @returns {*}
     * @private
     */
    var _saveApiKey = function(key) {

        try {
            var result = Utils.write_json_file(
                Config.SETTINGS_FILE,
                {key : key}
            );

            if (result) {
                return true;
            }
            else {
                var saveError = new SaveApiKeyError(
                    'API Key was not saved because of an error'
                );
                host.logger.error(saveError);
                throw saveError;
            }
        }
        catch(e) {
            host.logger.error(e);
            return e;
        }
    };

    var _dialog;

    try {
        _dialog = Utils.window("dialog", "Remove BG Settings", 350, 190 );
    }
    catch(e) {
        return new SettingsDialogError('Utils.window failed : ' + $.stack, $.stack);
    }

    try {

        var keyHolder = Config.API_KEY,
            obfuscatedKey = '';

        if (typeof(Config.API_KEY) == 'string') {
            obfuscatedKey = Config.API_KEY.replace(/./g, "*");
        }

        // Profile controls

        _dialog.getApiKeyBtn   = _dialog.add('button', [230, 15, 280, 45], 'Get API Key', {name: 'getkey'});
        _dialog.getApiKeyBtn.onClick = function() {

            _dialog.close();

            // Send an event to the UI to reload.
            new CustomEvent(
                Events.OPEN_URL,
                JSON.stringify({url: Config.PROFILE_API_KEY})
            ).dispatch();

            return false;
        }

        _dialog.apiKeyDummy= _dialog.add('edittext', [30, 50, 320, 90], obfuscatedKey);
        _dialog.apiKeyDummy.active = false;
        _dialog.apiKeyDummy.characters = 32;

        _dialog.apiKeyLabel   = _dialog.add('statictext', [30, 10, 320, 50], 'API Key');
        _dialog.apiKey        = _dialog.add('edittext',   [30, 50, 320, 90], Config.API_KEY);
        _dialog.apiKey.active = false;
        _dialog.apiKey.characters = 32;
        _dialog.apiKey.hide();

        // Prevent editing the apiKey field directly.

        _dialog.apiKey.onActivate = function() {
            _dialog.apiKey.active = false;
            _dialog.apiKey.text = keyHolder;
        }

        //  Spoof a password field.

        _dialog.apiKeyDummy.onActivate = function() {
            _dialog.apiKeyDummy.text = keyHolder;
        }

        _dialog.apiKeyDummy.onChange = function() {
            _dialog.apiKey.text = _dialog.apiKeyDummy.text;
            keyHolder = _dialog.apiKeyDummy.text;
        }

        _dialog.apiKeyDummy.onDeactivate = function() {
            // keyHolder = _dialog.apiKey.text;
            _dialog.apiKeyDummy.text = keyHolder.obfuscate();
        }

        // Cancel button

        _dialog.closeBtn = _dialog.add('button', [30, 100, 160, 160], 'Close', {name: 'close'});
        _dialog.closeBtn.onClick = function() {
            keyHolder = "";
            _dialog.close();
        };

        // Save Api Key button

        _dialog.saveBtn = _dialog.add('button', [170, 100, 320, 160], 'Save', {name: 'save'});
        _dialog.saveBtn.onClick = function() {

            try {
                _dialog.apiKey.text = keyHolder;

                host.logger.info('Save API key : ' + _dialog.apiKey.text);

                Config.API_KEY = _dialog.apiKey.text;

                // Save the API Key
                _saveApiKey(_dialog.apiKey.text);

                _dialog.close();

                // Send an event to the UI to reload.
                new CustomEvent(
                    Events.KEY_SAVED,
                    JSON.stringify({saved: true})
                ).dispatch();
            }
            catch(e) {
                host.logger.error(
                    new SaveApiKeyError(e.message, e.stack)
                );
            }

            return false;
        };

        return _dialog;
    }
    catch(e) {
        return new SettingsDialogError('The SettingsDialog could not be created. Error : ' + e);
    }
};



if (typeof(csInterface) == 'undefined' && typeof(CSInterface) != 'undefined') {
    var csInterface = new CSInterface();
}

/**
 * Global counter.
 * @type {number}
 */
var counter = counter || 0;

/**
 * Image resolutions constants.
 * @type {{"4k": number, medium: number, hd: number, regular: number}}
 */
var resolutions = {
    "regular" : 250000,
    "medium"  : 1500000,
    "hd"      : 4000000,
    "4k"      : 10000000,
};

/**
 * Get the USER_DATA folder.
 */
var userDataFolder = (function() {
    var _userDataFolder;
    try {
        _userDataFolder = csInterface.getSystemPath(SystemPath.USER_DATA);
    }
    catch(e) {
        try {
            _userDataFolder = Folder.userData;
        }
        catch(e) {
            alert('logger.info : ' + e);
        }
    }
    return _userDataFolder;
})();

/**
 * Event constants.
 * @type {{KEY_SAVED: string, OPEN_URL: string}}
 */
var Events = {
    KEY_SAVED : 'key_saved',
    OPEN_URL  : 'open_url',
    SLCT      : 'slct'
};

/**
 * Global Config object.
 * @type {{
 *     APP_NAME     : string,
 *     USER_DATA    : *,
 *     LOGFOLDER    : *,
 *     API_KEY      : *,
 *     API_ENDPIONT : *
 * }}
 */
var EXTENSION_ID = 'bg.remove.panel';
Config = {
    EXTENSION_ID     : EXTENSION_ID,
    APP_NAME         : EXTENSION_ID,
    USER_DATA        : userDataFolder +  '/' + EXTENSION_ID,
    LOG_FOLDER       : userDataFolder  + '/' + EXTENSION_ID + '/logs',
    SETTINGS_FILE    : userDataFolder  + '/' + EXTENSION_ID + '/removebg-settings.json',
    API_KEY          : '',
    API_REMOVE_BG    : 'https://api.remove.bg/v1.0/removebg',
    API_ACCOUNT      : 'https://api.remove.bg/v1.0/account',
    ACCOUNT          : undefined,
    PROFILE          : 'https://www.remove.bg/profile',
    PROFILE_API_KEY  : 'https://www.remove.bg/profile#api-key',
    PROFILE_CREDITS  : 'https://www.remove.bg/profile#credits',
    USER_AGENT       : 'Photoshop {ps} Plugin {ext}/CEP {cep} {os}',
    DEBUG            : true
};

/**
 * SettingsDialogError class.
 * @param message
 * @param stack
 * @constructor
 */
var SettingsDialogError = function(message, stack) {
    this.name    = "SettingsDialogError";
    this.message = message || "Unknown SettingsDialogError";
    this.stack   = stack;
};
SettingsDialogError.prototype = Error.prototype;

/**
 * ImageResolutionError
 * @param message
 * @param stack
 * @constructor
 */
var ImageResolutionError = function(message, stack) {
    this.name    = "ImageResolutionError";
    this.message = message || "The image is too large";
    this.stack   = stack;
};
ImageResolutionError.prototype = Error.prototype;

/**
 * ResizeImageError
 * @param message
 * @param stack
 * @constructor
 */
var ResizeImageError = function(message, stack) {
    this.name    = "ResizeImageError";
    this.message = message || "An unknown error occurred resizing the image";
    this.stack   = stack;
}
ResizeImageError.prototype = Error.prototype;

/**
 * Custom DeleteFileError.
 * @param message
 * @constructor
 */
var DeleteFileError = function(message) {
    this.name    = "DeleteFileError";
    this.message = (message || "The file was not deleted");
    this.code    = "EDELFIL";
}
DeleteFileError.prototype = Error.prototype;

/**
 * Custom ReadFileError.
 * @param message
 * @constructor
 */
var ReadFileError = function(message) {
    this.name    = "ReadFileError";
    this.message = (message || "The file could not be read");
    this.code    = "EREADF";
}
ReadFileError.prototype = Error.prototype;

/**
 * Custom ReadFileError.
 * @param message
 * @constructor
 */
var SaveResultError = function(message) {
    this.name    = "SaveResultError";
    this.message = (message || "The result could not be saved");
    this.code    = "ESAVRE";
}
SaveResultError.prototype = Error.prototype;

/**
 * Custom SaveApiKeyError.
 * @param message
 * @constructor
 */
var SaveApiKeyError = function(message, stack) {
    this.name    = "SaveApiKeyError";
    this.message = (message || "API Key was not saved : " + stack);
    this.stack   = stack;
}
SaveApiKeyError.prototype = Error.prototype;

/**
 * Custom RemoveBackgroundError.
 * @param message
 * @constructor
 */
var RemoveBackgroundError = function(message) {
    this.name    = "RemoveBackgroundError";
    this.message = (message || "The background could not be removed");
    this.code    = "EREMBG";
}
RemoveBackgroundError.prototype = Error.prototype;

/**
 * InstallInfoError
 * @param message
 * @param stack
 * @constructor
 */
var InstallInfoError = function(message, stack){
    this.name    = "InstallInfoError";
    this.message = message || "InstallInfo error";
    this.stack   = stack;
};
InstallInfoError.prototype = Error.prototype;

/**
 * GetExtensionError
 * @param message
 * @param stack
 * @constructor
 */
var GetExtensionError = function(message, stack){
    this.name    = "GetExtensionError";
    this.message = message || "GetExtensionError error";
    this.stack   = stack;
};
GetExtensionError.prototype = Error.prototype;

/**
 *
 * @param message
 * @param stack
 * @constructor
 */
var ApplicationInfoError = function(message, stack) {
    this.name    = 'ApplicationInfoError';
    this.message = message || 'ApplicationInfoError error';
    this.stack   = stack || '';
};
ApplicationInfoError.prototype = Error.prototype;

/**
 *
 * @param message
 * @param stack
 * @constructor
 */
var ExtensionInfoError = function(message, stack) {
    this.name    = 'ExtensionInfoError';
    this.message = message || 'ExtensionInfoError error';
    this.stack   = stack || '';
};
ExtensionInfoError.prototype = Error.prototype;

/**
 *
 * @param message
 * @param stack
 * @constructor
 */
var NoSuchFileError = function(message, stack) {
    this.name    = "NoSuchFileError";
    this.message = message || "The specified file does not exist";
    this.stack   = stack;
}
NoSuchFileError.prototype = Error.prototype;

/**
 * Create symbols for classes in global scope.
 */
var host,
    Config,
    Utils,
    Logger,
    logger,
    SettingsDialog;

var originalDocument  = null,
    originalSelection = null,
    tempDoc           = null,
    hasSelection      = false,
    wasResized        = false,
    selectionChannel  = null;


var Host = function(Config) {

    var ExternalObjectIsLoadedLib = false;
    var _logger;

    _logger = new Logger(Config.EXTENSION_ID, Config.LOG_FOLDER);
    _logger.clear();

    logger = _logger;

    /**
     * Get the API key
     * @returns {*}
     * @private
     */
    function _getApiKey() {

        var settings;

        _logger.info(JSON.stringify(Config));
        _logger.info('Config.SETTINGS_FILE : ' + Config.SETTINGS_FILE);
        _logger.info('Settings file exists : ' + (new File(Config.SETTINGS_FILE).exists));

        try {
            settings = Utils.read_json_file(Config.SETTINGS_FILE);
            if ( typeof(settings) == 'undefined') {
                _logger.error('Settings is not defined');
            }
            else if (typeof(settings.key) == 'undefined') {
                _logger.error('Settings.key is not defined');
            }
            else if ( typeof(settings.key) != 'string') {
                _logger.error('Settings.key is not a string (' + typeof(settings.key) + ')');
            }
            else if (settings.key.trim() == '') {
                _logger.error('Settings.key is empty string');
            }
            else {
                Config.API_KEY = settings.key;
                _logger.info('Config.API_KEY : ' + Config.API_KEY);
            }
        }
        catch(e) {
            _logger.error(e);
        }

        return Config.API_KEY;
    }

    /**
     * Save the API key to the settings file.
     * @param key
     * @returns {*}
     * @private
     */
    function _saveApiKey(key) {
        try {
            Config.API_KEY = key;
            return Utils.write_json_file(
                Config.SETTINGS_FILE,
                {key: key}
            );
        }
        catch(e) {
            return e;
        }
    }

    /**
     * Show the settings dialog.
     * @returns {string}
     * @private
     */
    function _showSettingsDialog() {
        var dialog;

        try {
            dialog = new SettingsDialog(Config);
            _logger.info(
                'Dialog is : {test}', {
                    test : typeof(dialog)
                });
            try {
                dialog.show();
            }
            catch(e) {
                _logger.error(new SettingsDialogError('dialog.show() failed : ' + $.stack))
            }
            return 'Dialog is a ' + typeof(dialog);
        }
        catch(e) {
            var errMessage = new SettingsDialogError('showSettingsDialog failed : ' + $.stack);
            _logger.error( errMessage );
            return errMessage;
        }
    }

    /**
     * Creates a web shortcut then opens it in the default browser.
     * @param address
     * @private
     */
    function _openInBrowser( address ) {
        try {
            Utils.write_exec(
                Folder.temp + '/' + now() + '-shortcut.url',
                '[InternetShortcut]' + '\r' + 'URL=' + encodeURI(address) + '\r'
            );
        }
        catch(e) {
            prompt("Visit " + address + " for more information.", address);
        }
    };

    /**
     * Create a new CSXSEvent.
     * @param   {string}    eventType
     * @param   {*}         data
     * @returns {CSXSEvent}
     * @private
     */
    function _getNewCSEvent(type, data) {

        _logger.info("Create new CSXSEvent(" + type + ", " + data + ")");

        var event = new CSXSEvent();
        event.type = type;
        event.data = data;
        return event;
    }

    /**
     * Load external object library.
     * @returns {boolean}
     * @private
     */
    function _loadExternalObject() {
        if (ExternalObjectIsLoadedLib) {
            _logger.info("[lib:PlugPlugExternalObject] already loaded");
            return true;
        }
        try {
            if (new ExternalObject("lib:\PlugPlugExternalObject")) {
                _logger.info("[lib:PlugPlugExternalObject] loaded", $.fileName, $.line);
                ExternalObjectIsLoadedLib = true;
                return ExternalObjectIsLoadedLib;
            }
        }
        catch (e) {
            _logger.error(e, $.fileName, $.line);
            throw new Error(e);
        }
    }

    /**
     * Confirm resizing the image before sending.
     * @returns {boolean}
     * @private
     */
    function _confirmImageResize() {
        return confirm(
            "Your image needs to be resized to meet our size limits. Would you like to resize and continue?"
        );
    }

    /**
     * Get size of selection or document.
     * @returns {{width: number, height: number}}
     * @private
     */
    function _getImageSize() {

        var selection = _getSelectionOrAll();

        _logger.info('getImageSize - selection : ' + typeof(selection));

        var width  = 0,
            height = 0;

        try {

            _logger.info('getImageSize - selection.bounds : ' + typeof(selection.bounds));

            width  = selection.bounds[2].as("px") - selection.bounds[0].as("px");
            height = selection.bounds[3].as("px") - selection.bounds[1].as("px");
        }
        catch(e) {
            _logger.error('getSelectionOrAll Error : ' + e);
        }

        _logger.info('typeof Math.toFixed : ' + typeof(Math.toFixed));

        _logger.info({
            width  : width,
            height : height,
            px     : width * height,
            mpix   : calcMegaPixels(width, height)
        }.toSource());

        return JSON.stringify({
            width  : width,
            height : height,
            px     : width * height,
            mpix   : calcMegaPixels(width, height)
        });
    }

    /**
     * Return the selected area or select all and return.
     * @returns {null|*}
     * @private
     */
    function _getSelectionOrAll() {

        var doc = activeDocument;

        _logger.info('getSelectionOrAll - doc : ' + doc.name);

        originalDocument = doc;
        currentSelection = doc.selection;
        hasSelection     = true;

        try {
            if (! currentSelection.bounds) {
                hasSelection = false;
            }
        }
        catch(e) {
            hasSelection = false;
        }

        _logger.info('getSelectionOrAll - hasSelection : ' + hasSelection);

        if (hasSelection) {
            originalSelection = [
                currentSelection.bounds[0].as("px"),
                currentSelection.bounds[1].as("px")
            ];
        }
        else {
            originalSelection = null;
            currentSelection.selectAll();
        }

        _logger.info('getSelectionOrAll - currentSelection : ' + typeof(currentSelection));

        return currentSelection;
    }

    /**
     * Get the name of the active doc.
     * @returns {*}
     */
    function _getActiveDocName() {
        return activeDocument.name;
    }

    /**
     * Create the USER_DATE folder if it does not exist.
     * @private
     */
    function _initDataFolder() {
        try {

            var dataFolder = Utils.folder(Config.USER_DATA);
            var logFolder  = Utils.folder(Config.LOG_FOLDER);

            return '_initDataFolder : ' + typeof(dataFolder) != 'undefined' && typeof(logFolder) != 'undefined';
        }
        catch(e) {
            alert('_initDataFolder : ' + e + ' - ' + $.fileName + ':' + $.line);
            return '_initDataFolder : ' + e;
        }
    }

    /**
     * Initialize the Host.
     * @param {string} extensionID
     */
    function _init() {

        var initFolders = _initDataFolder();

        if (typeof(Config.EXTENSION_ID) == 'undefined' && typeof($.global.extensionID) != 'undefined') {
            Config.EXTENSION_ID = $.global.extensionID;
        }
        $.global.logfolder = Config.LOG_FOLDER;
        $.global.Config    = Config;

        var apiKey = _getApiKey();
        if (typeof(apiKey) == 'string' && apiKey.length > 0) {
            Config.API_KEY = apiKey;
            $.global.API_KEY = apiKey;
        }
        _loadExternalObject();

        // app.notifiers.add("slct", new File("~/Downloads/test.js"), "Dcmn");

        // app.notifiers.add(
        //     "slct",
        //     File("~/Downloads/ps-notifier-test.js"),
        //     "Dcmn"
        // );

        return initFolders;
    }

    // Initialize the object.

    _init();

    /**
     * Return the public interface.
     */
    return {
        init : function() {
            return _init();
        },
        getApiKey : function() {
            return _getApiKey();
        },
        saveApiKey : function() {
            return _saveApiKey(key);
        },
        showSettingsDialog : function() {
            return _showSettingsDialog();
        },
        confirmImageResize : function() {
            return _confirmImageResize();
        },
        alert : function(message) {
            alert(message);
        },
        getImageSize : function() {
            return _getImageSize();
        },
        getActiveDocName : function() {
            return _getActiveDocName();
        },
        logger : _logger
    }
};

/**
 * Create an instance of the Host object.
 * @returns {boolean}
 */
function createHostInstance() {
    try {
        host = new Host(Config);
        return typeof(host) != 'undefined';
    }
    catch(e) {
        alert(e);
        return false;
    }
}

/**
 * Create a new custom event object.
 * @param type
 * @param data
 * @returns {CSXSEvent}
 * @constructor
 */
function CustomEvent(type, data) {
    var event  = new CSXSEvent();
    event.type = type;
    event.data = data;
    return event;
}

/**
 * Wrapper for CEP's evalFile.
 * @param theFilePath
 * @returns {*}
 */
function include(theFilePath) {
    try {
        if ((new File(theFilePath)).exists) {
            $.evalFile( theFilePath );
            return (new File(theFilePath)).name;
        }
        else {
            return theFilePath + ' does not exist';
        }
    }
    catch(e) {
        return e;
    }
}

/**
 * Escape JSON string.
 * @param str
 * @returns {void | string | never}
 */
function escapeJson(str) {
    return str.replace(/\\/g, "\\\\");
}

/**
 *
 * @param maxres
 * @returns {string}
 */
function verifyFileSize(maxres) {

    var doc,
        hasSelection,
        currentSelection,
        width,
        height,
        jpgOptions,
        file,
        megapix;

    doc = app.activeDocument;

    originalDocument = doc;
    currentSelection = doc.selection;
    hasSelection     = true;

    host.logger.info('------------------------------ VERIFY FILE SIZE (1) ------------------------------');

    try {
        if (! doc.selection.bounds) {
            hasSelection = false;
        }
        info(JSON.stringify({
            currentSelection : currentSelection.bounds,
            hasSelection : hasSelection
        }));
    }
    catch(e) {
        hasSelection = false;
    }

    if (hasSelection) {
        originalSelection = [
            currentSelection.bounds[0].as("px"),
            currentSelection.bounds[1].as("px")
        ];
    }
    else {
        originalSelection = null;
        doc.selection.selectAll();
    }

    host.logger.info('------------------------------ VERIFY FILE SIZE (2) ------------------------------');
    host.logger.info(JSON.stringify({
        originalSelection : originalSelection,
        hasSelection : hasSelection
    }));

    width  = doc.selection.bounds[2].as("px") - doc.selection.bounds[0].as("px");
    height = doc.selection.bounds[3].as("px") - doc.selection.bounds[1].as("px");

    megapix = (width * height) / 1000000;

    host.logger.info('------------------------------ VERIFY FILE SIZE (2) ------------------------------');
    host.logger.info(JSON.stringify({
        width  : width,
        height : height,
        size   : megapix
    }));

    // TODO: Remove Debug from production code.
    // maxres = megapix * 0.35;

    if ((width * height) > maxres) {

        host.logger.info('Image is too large. Will prompt user for resize confirmation');

        var confirmationMessage = _t(
            'Your image is {megapix} megapixels which exceeds the maximum size of {maxres} ' +
            'megapixels allowed by your plan. Would you like to resize the image then send?',
            { megapix : toFixed(megapix, 2), maxres : toFixed(maxres / 1000000, 2) }
        );

        host.logger.info(confirmationMessage);

        if ( ! confirm(confirmationMessage)) {
            host.logger.info('User declined to resize image');
            return '{"status": "cancel", "error": "user_cancelled"}';
        }

        host.logger.info('User opted to resize image');

        try {
            if (hasSelection) {

                host.logger.info('------------------------------ VERIFY FILE SIZE (3) ------------------------------');

                // Save the current selection in an alpha channel.

                selectionChannel = saveSelection();

                host.logger.info('Saved selection {s}', {s: selectionChannel.name});

                // Resize the image.

                resizeByMegapixels(maxres);

                host.logger.info('Resized image');

                // Re-load the selection from the alpha channel.
                loadSelection(selectionChannel);

                host.logger.info('Loaded previous selection {s}', {s: selectionChannel.name} );
            }
            else {
                host.logger.info('No previous selection. Using entire image');
                resizeByMegapixels(maxres);
                doc.selection.selectAll();
            }

            wasResized = true;

            host.logger.info(wasResized ? 'Image was resized' : 'Image was not resized');
        }
        catch(e) {
            host.logger.error(new ResizeImageError(e.message, e.stack));
            var err = new ResizeImageError('resize_image_error');
            return '{"status": "error", "error": "' + err.message + '"}';
        }
    }

    host.logger.info('------------------------------ VERIFY FILE SIZE (4) ------------------------------');

    host.logger.info('Attempting to copy selection');

    doc.selection.copy();

    width  = doc.selection.bounds[2].as("px") - doc.selection.bounds[0].as("px");
    height = doc.selection.bounds[3].as("px") - doc.selection.bounds[1].as("px");

    host.logger.info(JSON.stringify({
        width  : width,
        height : height,
        size   : (width * height) / 1000000
    }));

    host.logger.info('Creating temporary document');

    tempDoc = app.documents.add(
        new UnitValue(width, "px"),
        new UnitValue(height, "px"),
        72,
        "removebg",
        NewDocumentMode.RGB,
        DocumentFill.TRANSPARENT,
        1
    );

    tempDoc.paste();

    jpgOptions = new JPEGSaveOptions();

    jpgOptions.quality = 8;

    file = new File(File(Folder.temp).fsName + '/removebg.jpg');

    host.logger.info('Saving temporary document to {s}', {s: file.fsName});

    tempDoc.saveAs(file, jpgOptions, true, Extension.LOWERCASE);

    return '{"status": "ok", "path": "' + escapeJson(file.fsName) + '"}';
}

/**
 * Resize the current image to target megapixels.
 * @param width
 * @param height
 * @param maxres
 */
function resizeByMegapixels(maxres) {

    var startRulerUnits     = app.preferences.rulerUnits,
        startTypeUnits      = app.preferences.typeUnits,
        startDisplayDialogs = app.displayDialogs;

    var doc = app.activeDocument;

    try {
        app.displayDialogs         = DialogModes.NO;
        app.preferences.rulerUnits = Units.PIXELS;
        app.preferences.typeUnits  = TypeUnits.PIXELS;

        doc.changeMode(ChangeMode.RGB);

        var dWidth    = doc.width.value,
            dHeight   = doc.height.value,
            newWidth  = null,
            newHeight = null;

        host.logger.info('------------------------------ RESIZE BY MEGAPIXELS (1) ------------------------------');

        var myres = (dWidth * dHeight) / 1000000;
        var scale = maxres / (dWidth * dHeight);

        host.logger.info('Image resolution : {d}', {d: myres});
        host.logger.info('Resize scale : {d}', {d: scale});

        var _width  = Math.sqrt((dWidth * dWidth)   * scale),
            _height = Math.sqrt((dHeight * dHeight) * scale);

        host.logger.info('Document dimensions : W : {w}, H : {h}', {
            w : _width,
            h : _height
        });

        // calculateMegaPixels(doc.width, doc.height);

        if (dHeight > dWidth) {
            newHeight  = Math.sqrt((dHeight * dHeight) * scale);
            newHeight  = UnitValue(newHeight, "px");
        }
        else {
            newWidth  = Math.sqrt((dWidth * dWidth) * scale);
            newWidth  = UnitValue(newWidth, "px");
        }

        host.logger.info('New Document dimensions : W : {w}, H : {h}', {
            w : Math.sqrt((dWidth * dWidth) * scale),
            h : Math.sqrt((dHeight * dHeight) * scale)
        });

        host.logger.info(
            _t('Resize image to W : {nw}, H : {nh}, MP : {mp}', {
                nw : newWidth,
                nh : newHeight,
                mp : (_width * _height) / 1000000
            })
        );

        doc.resizeImage(newWidth, newHeight, null, ResampleMethod.BICUBIC);

        // Reset
        if (startDisplayDialogs !== undefined) { app.displayDialogs = startDisplayDialogs; }
        if (startRulerUnits     !== undefined) { app.preferences.rulerUnits = startRulerUnits; }
        if (startTypeUnits      !== undefined) { app.preferences.typeUnits = startTypeUnits; }

        return true;
    }
    catch(e) {

        host.logger.error('Resize By Megapixels error : {e}', {e : e});

        // Reset
        if (startDisplayDialogs !== undefined) { app.displayDialogs = startDisplayDialogs; }
        if (startRulerUnits     !== undefined) { app.preferences.rulerUnits = startRulerUnits; }
        if (startTypeUnits      !== undefined) { app.preferences.typeUnits = startTypeUnits; }

        throw new Error(e);
    }
}

/**
 * Generate a short unique ID with collision-checking.
 */
function shortUUID() {
    var _generatedUIDs = {};
    while (true) {
        var uid = ("0000" + ((Math.random() * Math.pow(36, 4)) | 0).toString(36)).slice(-4);
        if (!_generatedUIDs.hasOwnProperty(uid)) {
            _generatedUIDs[uid] = true;
            return uid;
        }
    }
}

/**
 * Save the current selection in an alpha channel mask.
 * @returns {Channel}
 */
function saveSelection() {
    var doc = activeDocument;

    var theSelection,
        theBounds,
        theChannel;

    try {
        theSelection = doc.selection;
        theSelection.contract("1px");
        theBounds    = theSelection.bounds;

        theChannel = doc.channels.add();
        theChannel.name = 'selection-' + shortUUID();

        doc.selection.store(theChannel);

        return theChannel;
    }
    catch(e) {
        return e;
    }
}

/**
 * Loads the passed Channel into a selection.
 * @param {Channel} theChannel	The Channel the selection was saved in.
 * @returns void
 */
function loadSelection(theChannel, doc) {

    if (typeof(doc) == 'undefined') {
        doc = activeDocument;
    }

    doc.selection.load(theChannel, SelectionType.REPLACE, false);

    doc.activeChannels = [
        app.activeDocument.channels.getByName('Red'),
        app.activeDocument.channels.getByName('Green'),
        app.activeDocument.channels.getByName('Blue'),
    ];

    return doc.selection;
}

/**
 * Cancel removing background.
 * @returns void
 */
function cancelRemoveBg() {
    tempDoc.close(SaveOptions.DONOTSAVECHANGES);
    originalDocument = null;
    tempDoc = null;
}

/**
 * Import the API result to layer from file.
 * @param   {string}    filename
 * @returns {string}
 */
function addLayerFromFile(filename) {

    var targetLayer = tempDoc.activeLayer;
    var file        = new File(filename);
    var newDoc      = open(file);
    var layer       = newDoc.activeLayer;
    var tempLayer   = layer.duplicate(tempDoc);

    try {
        newDoc.close(SaveOptions.DONOTSAVECHANGES);

        app.activeDocument = tempDoc;

        host.logger.info('------------------------------ ADD LAYER FROM FILE (1) ------------------------------');
        host.logger.info('Making layer mask from transparency');

        makeLayerMaskFromTransparency();

        host.logger.info('Unlock layer mask');

        unlockMask();

        host.logger.info('Move mask to layer');

        moveMaskToLayer(targetLayer.name);

        host.logger.info('Merge temp layer');

        tempLayer.merge();

        host.logger.info('Locking the layer mask');

        lockMask();

        var resultLayer = targetLayer.duplicate(originalDocument);

        tempDoc.close(SaveOptions.DONOTSAVECHANGES);

        app.activeDocument = originalDocument;
        originalDocument.selection.deselect();

        if (originalSelection != null) {

            host.logger.info('An original selection exists');

            if (wasResized && selectionChannel != null) {

                host.logger.info('The original image was resized, loadingn selection from alpha channel');

                originalDocument.selection.deselect();
                var tmpSelection = loadSelection(selectionChannel, originalDocument);
                var x = tmpSelection.bounds[0].as("px");
                var y = tmpSelection.bounds[1].as("px");
                originalDocument.selection.deselect();
                originalSelection = [x, y];
            }

            host.logger.info('Moving selection to original position');

            resultLayer.applyOffset(
                new UnitValue(originalSelection[0], "px"),
                new UnitValue(originalSelection[1], "px"),
                OffsetUndefinedAreas.WRAPAROUND
            );

            originalSelection = null;
        }

        host.logger.info('Hiding all layers except processed layer');

        for(var i = 1; i < originalDocument.artLayers.length; i++) {
            originalDocument.artLayers[i].visible = false;
        }

        originalDocument = null;
        tempDoc = null;

        app.runMenuItem(charIDToTypeID(("FtOn")));

        return "ok";
    }
    catch(e) {
        error('addLayerFromFile Error : ' + e);
        alert('addLayerFromFile Error : ' + e);
    }
}

function selectLayerPixels() {
    var id1268 = charIDToTypeID( "setd" );
    var desc307 = new ActionDescriptor();
    var id1269 = charIDToTypeID( "null" );
    var ref257 = new ActionReference();
    var id1270 = charIDToTypeID( "Chnl" );
    var id1271 = charIDToTypeID( "fsel" );
    ref257.putProperty( id1270, id1271 );
    desc307.putReference( id1269, ref257 );
    var id1272 = charIDToTypeID( "T   " );
    var ref258 = new ActionReference();
    var id1273 = charIDToTypeID( "Chnl" );
    var id1274 = charIDToTypeID( "Chnl" );
    var id1275 = charIDToTypeID( "Trsp" );
    ref258.putEnumerated( id1273, id1274, id1275 );
    desc307.putReference( id1272, ref258 );
    executeAction( id1268, desc307, DialogModes.NO )
}

function makeLayerMask(maskType) {
    if( maskType == undefined) maskType = 'RvlS' ; //from selection
    //requires a selection 'RvlS'  complete mask 'RvlA' otherThanSelection 'HdSl'
    var desc140 = new ActionDescriptor();
    desc140.putClass( charIDToTypeID('Nw  '), charIDToTypeID('Chnl') );
    var ref51 = new ActionReference();
    ref51.putEnumerated( charIDToTypeID('Chnl'), charIDToTypeID('Chnl'), charIDToTypeID('Msk ') );
    desc140.putReference( charIDToTypeID('At  '), ref51 );
    desc140.putEnumerated( charIDToTypeID('Usng'), charIDToTypeID('UsrM'), charIDToTypeID(maskType) );
    executeAction( charIDToTypeID('Mk  '), desc140, DialogModes.NO );
}

function makeLayerMaskFromTransparency() {
    var idMk = charIDToTypeID( "Mk  " );
    var desc22 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
    var idChnl = charIDToTypeID( "Chnl" );
    desc22.putClass( idNw, idChnl );
    var idAt = charIDToTypeID( "At  " );
    var ref7 = new ActionReference();
    var idChnl = charIDToTypeID( "Chnl" );
    var idChnl = charIDToTypeID( "Chnl" );
    var idMsk = charIDToTypeID( "Msk " );
    ref7.putEnumerated( idChnl, idChnl, idMsk );
    desc22.putReference( idAt, ref7 );
    var idUsng = charIDToTypeID( "Usng" );
    var idUsrM = charIDToTypeID( "UsrM" );
    var idTrns = charIDToTypeID( "Trns" );
    desc22.putEnumerated( idUsng, idUsrM, idTrns );
    executeAction( idMk, desc22, DialogModes.NO );

}

function unlockMask() {
    var idsetd = charIDToTypeID( "setd" );
    var desc37 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
    var ref16 = new ActionReference();
    var idLyr = charIDToTypeID( "Lyr " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idTrgt = charIDToTypeID( "Trgt" );
    ref16.putEnumerated( idLyr, idOrdn, idTrgt );
    desc37.putReference( idnull, ref16 );
    var idT = charIDToTypeID( "T   " );
    var desc38 = new ActionDescriptor();
    var idUsrs = charIDToTypeID( "Usrs" );
    desc38.putBoolean( idUsrs, false );
    var idLyr = charIDToTypeID( "Lyr " );
    desc37.putObject( idT, idLyr, desc38 );
    executeAction( idsetd, desc37, DialogModes.NO );
}

function lockMask() {
    // =======================================================
    var idsetd = charIDToTypeID( "setd" );
    var desc27 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
    var ref10 = new ActionReference();
    var idLyr = charIDToTypeID( "Lyr " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idTrgt = charIDToTypeID( "Trgt" );
    ref10.putEnumerated( idLyr, idOrdn, idTrgt );
    desc27.putReference( idnull, ref10 );
    var idT = charIDToTypeID( "T   " );
    var desc28 = new ActionDescriptor();
    var idUsrs = charIDToTypeID( "Usrs" );
    desc28.putBoolean( idUsrs, true );
    var idLyr = charIDToTypeID( "Lyr " );
    desc27.putObject( idT, idLyr, desc28 );
    executeAction( idsetd, desc27, DialogModes.NO );
}

function moveMaskToLayer(layerName) {
    // =======================================================
    var idslct = charIDToTypeID( "slct" );
    var desc39 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
    var ref17 = new ActionReference();
    var idChnl = charIDToTypeID( "Chnl" );
    var idChnl = charIDToTypeID( "Chnl" );
    var idMsk = charIDToTypeID( "Msk " );
    ref17.putEnumerated( idChnl, idChnl, idMsk );
    desc39.putReference( idnull, ref17 );
    var idMkVs = charIDToTypeID( "MkVs" );
    desc39.putBoolean( idMkVs, false );
    executeAction( idslct, desc39, DialogModes.NO );

    // =======================================================
    var idMk = charIDToTypeID( "Mk  " );
    var desc40 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
    var idChnl = charIDToTypeID( "Chnl" );
    desc40.putClass( idNw, idChnl );
    var idAt = charIDToTypeID( "At  " );
    var ref18 = new ActionReference();
    var idChnl = charIDToTypeID( "Chnl" );
    var idChnl = charIDToTypeID( "Chnl" );
    var idMsk = charIDToTypeID( "Msk " );
    ref18.putEnumerated( idChnl, idChnl, idMsk );
    var idLyr = charIDToTypeID( "Lyr " );
    ref18.putName( idLyr, layerName );
    desc40.putReference( idAt, ref18 );
    var idUsng = charIDToTypeID( "Usng" );
    var ref19 = new ActionReference();
    var idChnl = charIDToTypeID( "Chnl" );
    var idChnl = charIDToTypeID( "Chnl" );
    var idMsk = charIDToTypeID( "Msk " );
    ref19.putEnumerated( idChnl, idChnl, idMsk );
    var idLyr = charIDToTypeID( "Lyr " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idTrgt = charIDToTypeID( "Trgt" );
    ref19.putEnumerated( idLyr, idOrdn, idTrgt );
    desc40.putReference( idUsng, ref19 );
    executeAction( idMk, desc40, DialogModes.NO );
}
